unit uResolSudo1bis;

/////////  SUDOKU     //////////////////////////////////////////////////////////
//                         Code exprimental
//                         Conu sous Delphi 6
//                         Novembre 2013
//                         Gilbert GEYER
////////////////////////////////////////////////////////////////////////////////

interface

uses Windows, Dialogs, SysUtils, StdCtrls, Classes, Grids, Graphics, Math, StrUtils;

resourcestring
  ErrFileInexist = ' %s : n''existe pas !!!';
  ErrNbData1 = ' Grille de donnes errone !!!' + #13#10 + '(%d lignes au lieu de 9)';
  ErrNbData2 = ' %s : EXIT sur ligne de donnes errone !!!' + #13#10 + '(%d donnes au lieu de 9)';
  ErrNbData3 = ' %s : EXIT sur ligne de donnes errone !!!' + #13#10 + '(%s : fausse donne)';
  Grille81D = ' Grille de 81 donnes : Rsolue d''entre de jeu !';

  ErrManqueCandi = 'Erreur : Manque de candidat en case non rsolue L%dC%d';
  ErrCandiUniqueEnDoubleLi = ' : Erreur : Candidat Unique  %s apparat en Double dans Ligne %d';
  ErrCandiUniqueEnDoubleCo = ' : Erreur : Candidat Unique  %s apparat en Double dans Colonne %d';
  ErrCandiUniqueEnDoubleBl = ' : Erreur : Candidat Unique  %s apparat en Double dans bloc %d';

  ErrResEnDoubleLi = 'Erreur : Le rsultat %s apparat en Double dans Ligne %d';
  ErrResEnDoubleCo = 'Erreur : Le rsultat %s apparat en Double dans Colonne %d';
  ErrResEnDoubleBl = 'Erreur : Le rsultat %s apparat en Double dans Bloc %d';

  InfoResteCandiResultat = 'Il reste au moins un Candidat unique, ou en emplacement unique, ou forc en chane et qui ' + #13#10
    + 'est le rsultat pour la case repre dont le survol  la souris signalera la valeur.';

  rsCasesRosePale = ' les cases en rose ple sont celles dont le survol signale le candidat qui peut tre Elimin.';
  rsCasesVertPale = ' les cases en vert ple sont celles dont le survol signale le candidat qui en est le Rsultat.';

  // Remarque : Un certain nombre de messages s'effectuent sans faire appel  des resourcestring's

const
  SetDataOK: set of Char = ['0'..'9'];
  SetResOK: set of Char = ['1'..'9'];

type tSetOC = set of Char;

const
  clResManu = clMaroon;
  clResLogique = clGreen;
  clEffetDomino = clOlive;
  clEmplaJumeaux = $00AAFFFF; // Jaune Lum 200
  clCandiResultat = $00AAFFAA; // Vert ple Lum 200
  clCandiSupprimable = $00FFAAFF; // Rose ple Lum 200

var Couleur: tColor;
  ArrCol: array of tColor;

var SLCombin: tStringList;
procedure CombinerPparP(NChar: string; const P: byte);

procedure sms(Info: string);
procedure Trace(Info: string);
procedure Trace2(Info: string);

procedure ChronoStart;
function StrDuree: string;
function ToucheCla(t: integer): boolean; // Dtection appui Touche

type TCellule = record
    ValReso: char;
    CaseResolue: boolean;
    CoulCase: tColor;
    Candidats: tSetOC;
    NumRes: integer; // Numro dans l'ordre de rsolution
    Info: string;
    CElim: shortString; // Candidats proposs liminables
    CResu: char; // Candidat propos comme rsultat
    clFond: tColor;
  end;

type TGRTrav = array[1..9, 1..9] of TCellule;

type TPos = record Cand: tSetOC; Li: byte; Co: byte; end;
  TPositions = array of TPos;

type TEmplaJum = record J1, J2: Tpos; end;
  TEmplaJumeaux = array of TEmplaJum;

type tConfig = (cXWingLig, cXWingCol, cXWingBlo, cInterActBlocs, cSwordFLig, cSwordFCol, cJellyLig, cJellyCol, cSquirmbagLig, cSquirmbagCol);

function CandiToStr(const Candi: tSetOC): string;
function StrToCandi(const Str: string): tSetOC;
function StrPositions(const Positions: TPositions; k: boolean): string;
function NumBloc(const Li, Co: byte): byte;
procedure LiCoDeLiBlocCoBloc(Bloc, LiBloc, CoBloc: byte; var Li, Co: byte);

type TSudoku = object
    NomGrille: string;
    GrilleChargee, GrilleResolue: boolean;
    Grid: TDrawGrid;
    NCRes: integer; // Nombre de Cases Rsolues
    NDat: integer; // Nombre de Donnes dans [1..9]
    GrilleDatasValide: boolean;
    GRT: TGRTrav; // Grille active
    GrilleMem1: TGRTrav; // Grille clone
    LignesRes: array[1..9] of string;
    SetCandiLi, SetCandiCo, SetCandiBloc: array[1..9] of tSetOC;
    sCandiIllumine: shortString;

    function ChargerGrille(var SL: tStringList; iNomGrille: string): boolean;
    function ChargerFichier(FileName: string): boolean;
    function PermuterLiCo(const Tab: TGRTrav): TGRTrav;
    function RotaGrille(const Tab: TGRTrav; const AngleDeg: Integer): TGRTrav;
    procedure Reperer(const Po: TPositions; cl: tColor; SetC: tSetOC);

    function NbCasesAvecCandiEnLig(const Candi: char; const Li: byte): byte;
    function NbCasesAvecCandiEnCol(const Candi: char; const Co: byte): byte;
    function NbCasesAvecCandiEnBloc(const Candi: char; const Bloc: byte): byte;
    function NbCasesResolues(const Grille: TGRTrav): byte;

    function OccPosCandLi(const Candi: char; const Li: byte; var Posit: TPositions): byte;
    function OccPosCandCo(const Candi: char; const Co: byte; var Posit: TPositions): byte;
    function OccPosCandBloc(const Candi: char; const Bloc: byte; var Posit: TPositions): byte;

    function OccPosCandisLi(const Candis: tSetOC; const Li: byte; var Posit: TPositions): byte;
    function OccPosCandisCo(const Candis: tSetOC; const Co: byte; var Posit: TPositions): byte;
    function OccPosCandisBloc(const Candis: tSetOC; const Bloc: byte; var Posit: TPositions): byte;
    function OccPosCandisNus(const DansLCouB: char; const Candis: tSetOC; const LCouB: byte; var Posit: TPositions): byte;
    function OccPosCandisGrappe(const Candis: tSetOC; var Posit: TPositions): byte;

    function EmplaOuCandiUniqueEn(const Li, Co: byte; var Candi: char): string;
    function ResolAvecEmplaOuCandiUnique(Afficher: boolean): boolean;

    function IDEmplaJumeauxEnLi(const Li: byte; var Ejum: TEmplaJumeaux): boolean;
    function IDEmplaJumeauxEnCo(const Co: byte; var Ejum: TEmplaJumeaux): boolean;
    function IDEmplaJumeauxEnBloc(const Bloc: byte; var Ejum: TEmplaJumeaux): boolean;

    function EmplaJumeauxEnLi(const Li: byte; var Candi: char; var Posit: TPositions): boolean;
    function EmplaJumeauxEnCo(const Co: byte; var Candi: char; var Posit: TPositions): boolean;
    function EmplaJumeauxEnBloc(const Bloc: byte; var Candi: char; var Posit: TPositions): boolean;

    function ResolEmplaJumeaux: boolean;

    function RepererElimParXWing: boolean;
    function RepererElimParInterActBlocs: boolean;
    function RepererElimInteractBloques: boolean;
    function RepererElimParSwordFish: boolean;
    function RepererElimParJellyfish: boolean;
    function RepererElimParSquirmbag: boolean;

    function OccPosNupletsCaches(const DansLCouB: char; const Candis: tSetOC; const LCouB: byte; var Posit: TPositions): byte;
    function OccPosNupletsNus(const DansLCouB: char; const Candis: tSetOC; const LCouB: byte; var Posit: TPositions): byte;
    function RepererElimSiNupletsCaches(const NU: byte): boolean;
    function RepererElimSiNupletsNus(const NU: byte): boolean;
    function RepererElimSiRectangleInterdit: boolean;

    function ChaineForceePaires: boolean;
    function ChaineForceePcasesNcandidats: boolean;
    function XYZ_Wing(var Li, Co: byte; var CandRes: char): boolean;
    function W_Wing: boolean;
    function Y_Wing: boolean; // aussi nomme XY_Wing
    function RepererChaineExclusion: boolean;

    function ResolAleatoire: boolean;

    function GrilleClone(const Grille: TGRTrav): TGRTrav;
    procedure InitGrilleMem1;

    function GetCandLi(const Li: byte): tSetOC;
    function GetCandCo(const Co: byte): tSetOC;
    function GetCandBloc(const Bl: byte): tSetOC;

    procedure CandiToRes(Candi: Char; Li, Co: byte; Coul: tColor; Afficher: boolean);
    // Modifs manuelles de la grille :
    procedure ModifManuCandis(Candis: ShortString; Li, Co: byte; Modif: char); // Modif = A pour Ajouter, et S pour Supprimer
    procedure ModifManuValRes(NewVal: Char; Li, Co: byte; Modif: char); // Modif = R pour Remplacer et S pour Supprimer
    // Contrles :
    function ErrCaseVideNonResolue: boolean;
    function ErrValResDoublon: boolean;
    function ControleRes: string;
    function TestCandiEtRES: boolean; // <- Result = True si Erreur suite  un joker saisi manuellement

    // Affichages :
    procedure RAZGrille;
    procedure ViderGrilleInitCandi;
    procedure AffCase(Val: Char; Li, Co: byte);

    procedure AffCandi(const Li, Co: integer; const clFond: tColor);
    // <- Si clFond = 2 alors couleurs alternes clWhite/clAqua sinon case de couleur clFond
    procedure RaffraichirAffichageCandidats;
    procedure RaffraichirAffichageGrille;
    // Manipulations Grille :
    function SLGrille: tStringList;
    function GrillePermuterCo1Co2(const Co1, Co2: byte): tStringList;
    function GrillePermuterLi1Li2(const Li1, Li2: byte): tStringList;
    function GrillePermuterGD: tStringList;
    function GrillePermuterHB: tStringList;
    function GrillePermuterLiCo: tStringList;
    function GrilleRotation(const AngleDeg: Integer): tStringList;
    function GrillePermuterVr1Vr2(const Vr1, Vr2: char): tStringList;
  end;

var Sudo: TSudoku;

implementation

uses uSudoMain1bis;

// A) Utilitaires Divers: -------------------------------------------------------

procedure sms(Info: string);
begin
  showMessage(Info);
end;

procedure Trace(Info: string);
begin
  frmSudo.RE.Lines.Add(Info); frmSudo.RE.Update; ;
end;

procedure Trace2(Info: string);
begin
  frmSudo.RE2.Lines.Add(Info); frmSudo.RE2.Update; ;
end;

function clAleatoireFond(const monSeuil: byte; CouleurInterdite1, CouleurInterdite2: tColor): tColor;
var Gris, R, G, B: integer;
begin
  repeat
    R := random(256); G := random(256); B := random(256);
    Gris := (R + G + B) div 3;
    Result := RGB(R, G, B);
  until (Gris >= monSeuil) and (Result <> CouleurInterdite1) and (Result <> CouleurInterdite2);
end;

function clFondG(i: integer): tColor;
begin
  case i of
    0..5: Result := ArrCol[i];
  else Result := clAleatoireFond(90, clAqua, clWhite);
  end;
end;

// Chronomtre :
var FFrequency: Int64; // Frquence du compteur hautes performances.
  FStart, FStop: Int64; // Valeurs du compteur au dbut et  la fin du chrono.
  Duree: Extended; // Dure finale, en secondes.

procedure ChronoStart; // Initialisation du compteur hautes performances, et dbut du chronomtrage.
begin if not QueryPerformanceFrequency(FFrequency) then
    raise Exception.Create('Pas de compteur hautes performances.');
  QueryPerformanceCounter(FStart);
end;

function TempsToStr(Duree: Extended): string;
begin
  if Duree < 0.001 then
    Result := FormatFloat('#####.##', Duree * 1000000) + ' s'
  else
  begin
    if Duree < 1 then
      Result := FormatFloat('#####.##', Duree * 1000) + ' ms'
    else
      Result := FormatFloat('#####.##', Duree) + ' sec';
  end
end;

function StrDuree: string;
begin
  QueryPerformanceCounter(FStop);
  Duree := (FStop - FStart) / FFrequency; // Fin de chronomtrage, conversion du temps coul en secondes.
  Result := TempsToStr(Duree);
end;

function ToucheCla(t: integer): boolean; // Dtection appui Touche : Utilis pour cas de saisies manuelles aberrantes gnrant une boucle sans fin
//        utilisations : if ToucheCla(VK_ESCAPE) then
//                       if ToucheCla(Ord('R')) then
begin Result := ((GetAsyncKeyState(t) and 32768) <> 0)
end;

function NumCaseBloc(LiBloc, Cobloc: byte): byte;
// Renvoie le numro [1..9] pour Libloc et CoBloc dans [1..3]
begin
  Result := (LiBloc - 1) * 3 + CoBloc;
end;

function LiDeLiBloc(const Bloc, LiBloc: byte): byte;
//       Renvoie Li en fonction du Bloc et de la position LiBloc dans le bloc
begin
  Result := 0;
  case Bloc of
    1..3: Result := liBloc;
    4..6: Result := liBloc + 3;
    7..9: Result := liBloc + 6;
  end;
end;

function CoDeCoBloc(const Bloc, CoBloc: byte): byte;
//       Renvoie Co en fonction du Bloc et de la position CoBloc dans le bloc
begin
  Result := 0;
  case Bloc of
    1, 4, 7: Result := CoBloc;
    2, 5, 8: Result := CoBloc + 3;
    3, 6, 9: Result := CoBloc + 6;
  end;
end;

procedure LiCoDeLiBlocCoBloc(Bloc, LiBloc, CoBloc: byte; var Li, Co: byte);
// Renvoie Li,Co en fonction du Bloc et de la position dans le bloc
begin
  Li := LiDeLiBloc(Bloc, LiBloc);
  Co := CoDeCoBloc(Bloc, CoBloc);
end;

procedure LiBlocCoBlocDeLiCo(const Li, Co: byte; var LiBloc, CoBloc: byte);
// Renvoie la position LiBloc, CoBloc dans le Bloc en fonction de Li,Co
begin
  LiBloc := (Li - 1) mod 3 + 1;
  CoBloc := (Co - 1) mod 3 + 1;
end;

function NumBloc(const Li, Co: byte): byte;
// Renvoie le numro du bloc associ a la ligne et la colonne
// Les blocs sont numrots comme suit :
//  1 2 3
//  4 5 6
//  7 8 9 et chaque bloc contient 9 cellules
begin
  Result := ((Li - 1) div 3) * 3 + ((Co - 1) div 3) + 1;
end;

function NumBlocPerm(const B: byte): byte;
// Convertit le numro du bloc en sa version ou Li et Co ont t permuts
begin
  Result := B;
  case B of
    1: Result := B;
    2: Result := 4;
    3: Result := 7;
    4: Result := 2;
    5: Result := B;
    6: Result := 8;
    7: Result := 3;
    8: Result := 6;
    9: Result := B;
  end;
end;

function CandiToStr(const Candi: tSetOC): string;
var i: integer; c: char;
begin
  Result := '';
  if Candi = [] then EXIT;
  for i := 49 to 57 do begin
    c := Chr(i);
    if c in Candi then Result := Result + c;
  end;
end;

function StrToCandi(const Str: string): tSetOC;
var i: integer;
begin
  Result := [];
  if Str = '' then EXIT;
  for i := 1 to length(Str) do if Str[i] in SetResOK then Result := Result + [Str[i]];
end;

function StrPositions(const Positions: TPositions; k: boolean): string;
// Si k = true alors configuration normale sinon cas d'inversion Li-Co
var i: byte;
begin
  Result := '';
  for i := Low(Positions) to High(Positions) do begin
    if k then Result := Result + #13#10 + Format('- %s en L%dC%d', [CandiToStr(Positions[i].Cand), Positions[i].Li, Positions[i].Co])
    else Result := Result + #13#10 + Format('- %s en L%dC%d', [CandiToStr(Positions[i].Cand), Positions[i].Co, Positions[i].Li])
  end;
end;

function MemeCase(const P1, P2: TPos): boolean;
begin
  Result := (P1.Li = P2.Li) and (P1.Co = P2.Co);
end;

function MemeBloc(const P1, P2: TPos): boolean;
begin
  Result := NumBloc(P1.Li, P1.Co) = NumBloc(P2.Li, P2.Co);
end;

function DoublonDans(const Dans: TPositions): boolean;
var i, j: byte; Doublon: tPos;
begin
  Result := false;
  for i := 0 to High(Dans) do begin
    Doublon := Dans[i];
    for j := i + 1 to High(Dans) do begin
      if MemeCase(Doublon, Dans[j]) then begin Result := true; end;
    end;
  end;
end;

function MemeLig(const P1, P2: TPos): boolean;
begin
  Result := (P1.Li = P2.Li);
end;

function MemeCol(const P1, P2: TPos): boolean;
begin
  Result := (P1.Co = P2.Co);
end;

function DeuxAlignes(const P1, P2: TPos): boolean;
begin Result := (P1.Li = P2.Li) or (P1.Co = P2.Co); end;

function TroisAlignes(const P1, P2, P3: TPos): boolean;
begin
  Result := ((P1.Li = P2.Li) and (P1.Li = P3.Li))
    or ((P1.Co = P2.Co) and (P1.Co = P3.Co));
end;

function DeuxDansMemeBloc(const P1, P2: TPos): boolean;
begin Result := NumBloc(P1.Li, P1.Co) = NumBloc(P2.Li, P2.Co); end;

function EnEquerre(const P1, P2, P3: TPos): boolean;
begin
  Result := ((P1.Li = P2.Li) and (P1.Co = P3.Co))
    or ((P1.Li = P3.Li) and (P1.Co = P2.Co));
end;

function EnEquerre4ieme(const P1, P2, P3: TPos; var P4: TPos): boolean;
begin
  Result := False;
  if ((P1.Li = P2.Li) and (P1.Co = P3.Co)) then begin P4.Li := P3.Li; P4.Co := P2.Co; Result := true; end;
  if ((P1.Li = P3.Li) and (P1.Co = P2.Co)) then begin P4.Li := P2.Li; P4.Co := P3.Co; Result := true; end;
  if ((P2.Li = P3.Li) and (P3.Co = P1.Co)) then begin P4.Li := P1.Li; P4.Co := P2.Co; Result := true; end;
  if ((P1.Li = P2.Li) and (P2.Co = P3.Co)) then begin P4.Li := P3.Li; P4.Co := P1.Co; Result := true; end;
  if ((P2.Li = P3.Li) and (P2.Co = P1.Co)) then begin P4.Li := P1.Li; P4.Co := P3.Co; Result := true; end;
end;

function EnRectangle(const P1, P2, P3, P4: TPos): boolean;
begin
  Result := (DeuxAlignes(P1, P2) and DeuxAlignes(P3, P4) and DeuxAlignes(P1, P3) and DeuxAlignes(P2, P4))
    or (DeuxAlignes(P1, P3) and DeuxAlignes(P4, P2) and DeuxAlignes(P1, P4) and DeuxAlignes(P3, P2));
end;

function EnRectanglePo(const Po: TPositions): boolean;
var i: byte;
begin
  Result := false;
  SLCombin := tStringList.Create;
  CombinerPparP('01234567', 4);
  for i := 0 to SLCombin.Count - 1 do begin
    Result := EnRectangle(Po[StrToInt(SLCombin[i][1])], Po[StrToInt(SLCombin[i][1])], Po[StrToInt(SLCombin[i][1])], Po[StrToInt(SLCombin[i][1])]);
    if Result then EXIT;
  end;
  SLCombin.Free;
end;

// B ) =============================================================================

function TSudoku.ChargerGrille(var SL: tStringList; iNomGrille: string): boolean;
var li, co, Bloc, liBloc, CoBloc: byte; data: char; po: integer;
  SetLignesRes, SetColonnesRes, SetBlocRes: array[1..9] of tSetOC; // ['1'..'9']
begin
  RAZGrille;
  Result := False; NomGrille := iNomGrille; GrilleResolue := False; NCRes := 0; NDat := 0;
  if SL.count = 0 then EXIT;
  while (SL.count > 9) and (SL[0] = '') do SL.Delete(0);
  li := SL.count - 1;
  while (SL.count > 9) and (SL[li] = '') do begin SL.Delete(li); dec(li); end;
  if SL.Count <> 9 then begin // Vrification Datas n 1
    sms(format(ErrNbData1, [SL.Count])); EXIT;
  end;

  for li := 0 to 8 do begin
    if length(SL[li]) <> 9 then begin // Vrification Datas n 2
      sms(format(ErrNbData2, [SL[li], length(SL[li])])); EXIT;
    end;
    LignesRes[li + 1] := SL[li];
  end;

  for Li := 1 to 9 do begin
    for Co := 1 to 9 do begin
      data := SL[Li - 1][co];
      if not (data in SetDataOk) then begin // Vrification Datas n 3
        sms(Format(ErrNbData3, [SL[Li - 1], data])); EXIT;
      end;
      GRT[li, co].ValReso := data;
      if Data <> '0' then begin
        GRT[li, co].CaseResolue := True; inc(NDat); NCRes := NDat;
        GRT[li, co].NumRes := NDat;
        GRT[li, co].CoulCase := clBlack;
        AffCase(Data, Li, Co);
      end else begin
        GRT[li, co].CaseResolue := False; GRT[li, co].ValReso := #0;
      end;
      GRT[li, co].Candidats := []; // Pas de condidats  ce stade
      GRT[li, co].Info := ''; GRT[li, co].CElim := ''; GRT[li, co].CResu := '*';
      GRT[li, co].clFond := 2;
    end;
  end;
  // Sets Res :
  for Li := 1 to 9 do begin
    SetLignesRes[Li] := [];
    for Co := 1 to 9 do begin
      if GRT[li, co].CaseResolue then SetLignesRes[Li] := SetLignesRes[Li] + [GRT[li, co].ValReso];
    end;
  end;

  for Co := 1 to 9 do begin
    SetColonnesRes[Co] := [];
    for Li := 1 to 9 do begin
      if GRT[li, co].CaseResolue then SetColonnesRes[Co] := SetColonnesRes[Co] + [GRT[li, co].ValReso];
    end;
  end;

  for Bloc := 1 to 9 do begin
    SetBlocRes[Bloc] := [];
    for LiBloc := 1 to 3 do begin
      for CoBloc := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(Bloc, LiBloc, CoBloc, Li, Co);
        if GRT[li, co].CaseResolue then SetBlocRes[Bloc] := SetBlocRes[Bloc] + [GRT[li, co].ValReso];
      end;
    end;
  end;
  // Candidats :
  for Bloc := 1 to 9 do begin
    SetCandiBloc[Bloc] := [];
    for LiBloc := 1 to 3 do begin
      for CoBloc := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(Bloc, LiBloc, CoBloc, Li, Co);
        if not GRT[li, co].CaseResolue then begin
          GRT[li, co].Candidats := SetResOk - SetBlocRes[Bloc] - SetLignesRes[Li] - SetColonnesRes[Co];
          SetCandiBloc[Bloc] := SetCandiBloc[Bloc] + GRT[li, co].Candidats;
        end;
      end;
    end;
  end;

  for Li := 1 to 9 do begin
    SetCandiLi[Li] := [];
    for Co := 1 to 9 do SetCandiLi[Li] := SetCandiLi[Li] + GRT[li, co].Candidats;
  end;
  for Co := 1 to 9 do begin
    SetCandiCo[Co] := [];
    for Li := 1 to 9 do SetCandiCo[Co] := SetCandiCo[Co] + GRT[li, co].Candidats;
  end;

  GrilleDatasValide := True;
  // Affichage :
  for Li := 1 to 9 do begin
    for Co := 1 to 9 do begin
      if GRT[li, co].CaseResolue
        then AffCase(GRT[Li, Co].ValReso, Li, Co)
      else AffCandi(Li, Co, 2);
    end;
  end;
  if NCRes = 81 then begin GrilleResolue := True; sms(Grille81D); end;
  Result := True; GrilleChargee := true; sCandiIllumine := '';
  frmSudo.RE2.Clear;
end; // TSudoku.ChargerGrille

function TSudoku.ChargerFichier(FileName: string): boolean;
var SL: tStringList;
begin
  Result := FileExists(FileName);

  if not Result then begin sms(Format(ErrFileInexist, [FileName])); EXIT; end;
  SL := tStringList.create;
  SL.LoadFromFile(FileName);

  Result := ChargerGrille(SL, FileName);
  SL.Free;
end;

function TSudoku.PermuterLiCo(const Tab: TGRTrav): TGRTrav;
var Li, Co: byte;
begin
  for Li := low(Tab) to High(Tab) do begin
    for Co := low(Tab[Li]) to High(Tab[Li]) do Result[Co, Li] := Tab[Li, Co];
  end;
end;

function TSudoku.RotaGrille(const Tab: TGRTrav; const AngleDeg: Integer): TGRTrav;
var dPhi: Extended;
  Rxx, Ryy, xc, yc: Double; Li, Co, Lir, Cor: byte;
begin
  dPhi := DegToRad(AngleDeg);
  xc := 5; yc := 5;
  for Li := 1 to 9 do begin
    for Co := 1 to 9 do begin
      Rxx := Co - xc; Ryy := Li - yc;
      // Application de la matrice de rotation par rapport au centre de coordonnes xc,yc
      Cor := round(xc + (Rxx * cos(dPhi) - Ryy * sin(dPhi)));
      Lir := round(yc + (Rxx * sin(dPhi) + Ryy * cos(dPhi)));
      with Result[Lir, Cor] do begin
        ValReso := Tab[Li, Co].ValReso;
        CaseResolue := Tab[Li, Co].CaseResolue;
        CoulCase := Tab[Li, Co].CoulCase;
        Candidats := Tab[Li, Co].Candidats;
        NumRes := Tab[Li, Co].NumRes;
        Info := Tab[Li, Co].Info;
        CElim := Tab[Li, Co].CElim;
        CResu := Tab[Li, Co].CResu;
        clFond := Tab[Li, Co].clFond;
      end;
    end;
  end;
end;

procedure TSudoku.Reperer(const Po: TPositions; cl: tColor; SetC: tSetOC);
var i: byte;
begin
  for i := 0 to high(Po) do begin
    GRT[Po[i].Li, Po[i].Co].clFond := cl;
  end;
end;

function TSudoku.TestCandiEtRES: boolean;
// Result = True si Erreur suite  injection d'un joker faux
var Li, Co, LiB, CoB, Bl: byte; sCand: string;

  function DeuxiemeCandEnLi(const Candi: char; const Li, CoP: byte): boolean;
  var C: byte;
  begin
    Result := False; if CoP = 9 then EXIT;
    for C := CoP + 1 to 9 do begin
      if GRT[Li, C].Candidats = [Candi] then begin
        Result := True; EXIT;
      end;
    end;
  end;

  function DeuxiemeCandEnCo(const Candi: char; const LiP, Co: byte): boolean;
  var L: byte;
  begin
    Result := False; if LiP = 9 then EXIT;
    for L := LiP + 1 to 9 do begin
      if GRT[L, Co].Candidats = [Candi] then begin
        Result := True; EXIT;
      end;
    end;
  end;

  function DeuxiemeCandEnBloc(const Candi: char; const Bl, LiBP, CoBP: byte): boolean;
  var LiB, CoB, Li, Co, L1, C1: byte;
  begin
    Result := False;
    if (LiBP = 3) and (CoBP = 3) then EXIT;
    if CoBP = 3 then begin C1 := 1; L1 := LiBP + 1; end else begin C1 := CoBp + 1; L1 := LiBp; end;
    for LiB := L1 to 3 do begin
      for CoB := C1 to 3 do begin
        LiCoDeLiBlocCoBloc(Bl, LiB, CoB, Li, Co);
        if (GRT[Li, Co].Candidats <> []) and (GRT[Li, Co].Candidats = [Candi]) then begin
          Result := True; EXIT;
        end;
      end;
    end;
  end;

  function DeuxiemeRESEnLi(const RES: char; const Li, CoP: byte): boolean;
  var C: byte;
  begin
    Result := False; if CoP = 9 then EXIT;
    for C := CoP + 1 to 9 do begin
      if GRT[Li, C].ValReso = RES then begin
        Result := True; EXIT;
      end;
    end;
  end;

  function DeuxiemeRESEnCo(const RES: char; const LiP, Co: byte): boolean;
  var L: byte;
  begin
    Result := False; if LiP = 9 then EXIT;
    for L := LiP + 1 to 9 do begin
      if GRT[L, Co].ValReso = RES then begin
        Result := True; EXIT;
      end;
    end;
  end;

  function DeuxiemeRESEnBloc(const RES: char; const Bl, LiBP, CoBP: byte): boolean;
  var LiB, CoB, Li, Co: byte;
  begin
    Result := False;
    if (LiBP = 3) and (CoBP = 3) then EXIT;
    for LiB := 1 to 3 do begin
      for CoB := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(Bl, LiB, CoB, Li, Co);
        if (LiB = LiBP) and (CoB = CoBP) then Continue;
        if GRT[Li, Co].ValReso = RES then begin
          Result := True; EXIT;
        end;
      end;
    end;
  end;

begin
  Result := False;
  // A : Candidats
  for Bl := 1 to 9 do begin
    for LiB := 1 to 3 do begin
      for CoB := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(Bl, LiB, CoB, Li, Co);
        if GRT[Li, Co].CaseResolue then Continue;
        sCand := CandiToStr(GRT[Li, Co].Candidats);
        if (length(sCand) > 1) or (length(sCand) = 0) then Continue;
        if DeuxiemeCandEnBloc(sCand[1], Bl, LiB, CoB) then begin
          Result := True;
          sms(Format(ErrCandiUniqueEnDoubleBl, [sCand[1], Bl]));
          EXIT;
        end;
      end;
    end;
  end;

  for Li := 1 to 9 do begin
    for Co := 1 to 9 do begin
      if GRT[Li, Co].CaseResolue then Continue;
      if GRT[Li, Co].Candidats = [] then begin
        Result := True;
        sms(Format(ErrManqueCandi, [Li, Co]));
        EXIT;
      end;
      sCand := CandiToStr(GRT[Li, Co].Candidats);
      if (length(sCand) > 1) or (length(sCand) = 0) then Continue;
      if DeuxiemeCandEnLi(sCand[1], Li, Co) then begin
        Result := True;
        sms(Format(ErrCandiUniqueEnDoubleLi, [sCand[1], Li]));
        EXIT;
      end;
    end;
  end;

  for Co := 1 to 9 do begin
    for Li := 1 to 9 do begin
      if GRT[Li, Co].CaseResolue then Continue;
      if GRT[Li, Co].Candidats = [] then begin
        Result := True;
        sms(Format(ErrManqueCandi, [Li, Co]));
        EXIT;
      end;
      sCand := CandiToStr(GRT[Li, Co].Candidats);
      if (length(sCand) > 1) or (length(sCand) = 0) then Continue;
      if DeuxiemeCandEnCo(sCand[1], Li, Co) then begin
        Result := True;
        sms(Format(ErrCandiUniqueEnDoubleCo, [sCand[1], Co]));
        EXIT;
      end;
    end;
  end;

  // B : Resultats
  for Bl := 1 to 9 do begin
    for LiB := 1 to 3 do begin
      for CoB := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(Bl, LiB, CoB, Li, Co);
        if GRT[Li, Co].CaseResolue then begin
          if DeuxiemeRESEnBloc(GRT[Li, Co].ValReso, Bl, LiB, CoB) then begin
            Result := True;
            sms(Format(ErrResEnDoubleBl, [GRT[Li, Co].ValReso, Bl]));
            EXIT;
          end;
        end;
      end;
    end;
  end;
  for Li := 1 to 9 do begin
    for Co := 1 to 9 do begin
      if GRT[Li, Co].CaseResolue then begin
        if DeuxiemeRESEnLi(GRT[Li, Co].ValReso, Li, Co) then begin
          Result := True;
          sms(Format(ErrResEnDoubleLi, [GRT[Li, Co].ValReso, Li]));
          EXIT;
        end;
      end;
    end;
  end;
  for Co := 1 to 9 do begin
    for Li := 1 to 9 do begin
      if GRT[Li, Co].CaseResolue then begin
        if DeuxiemeRESEnCo(GRT[Li, Co].ValReso, Li, Co) then begin
          Result := True;
          sms(Format(ErrResEnDoubleCo, [GRT[Li, Co].ValReso, Co]));
          EXIT;
        end;
      end;
    end;
  end;
end; // TSudoku.TestCandiEtRES

procedure TSudoku.CandiToRes(Candi: Char; Li, Co: byte; Coul: tColor; Afficher: boolean);
//        Procedure fondamentale qui dclenche le cas chant l'effet domino
//        lorsque le 'Candi' prend le statut de Rsultat pour la case Li,Co

  procedure ActuCElim(const L, C: byte);
  var po: integer;
  begin
    if GRT[L, C].CElim <> '' then begin
      po := pos(Candi, GRT[L, C].CElim);
      if po > 0 then Delete(GRT[L, C].CElim, po, 1);
      if GRT[L, C].CElim = '' then GRT[L, C].Info := '';
    end;
  end;

  procedure ActuSetCandLignes(Li: byte);
  var Co: byte; sCand: string;
  begin
    SetCandiLi[Li] := SetCandiLi[Li] - [Candi];
    for Co := 1 to 9 do begin
      if GRT[li, co].CaseResolue then Continue;
      GRT[li, co].Candidats := GRT[li, co].Candidats - [Candi];
      ActuCElim(Li, Co);
      sCand := CandiToStr(GRT[li, co].Candidats);
      if length(sCand) = 1 then CandiToRes(sCand[1], Li, Co, clEffetDomino, Afficher);
    end;
  end;

  procedure ActuSetCandColonnes(Co: byte);
  var Li: byte; sCand: string;
  begin
    SetCandiCo[Co] := SetCandiCo[Co] - [Candi];
    for Li := 1 to 9 do begin
      if GRT[li, co].CaseResolue then Continue;
      GRT[li, co].Candidats := GRT[li, co].Candidats - [Candi];
      ActuCElim(Li, Co);
      sCand := CandiToStr(GRT[li, co].Candidats);
      if length(sCand) = 1 then CandiToRes(sCand[1], Li, Co, clEffetDomino, Afficher);
    end;
  end;

  procedure ActuSetCandBlocs(Bloc: byte);
  var LiBloc, CoBloc, Li, Co: byte; sCand: string;
  begin
    SetCandiBloc[Bloc] := SetCandiBloc[Bloc] - [Candi];
    for LiBloc := 1 to 3 do begin
      for CoBloc := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(Bloc, LiBloc, CoBloc, Li, Co);
        if GRT[li, co].CaseResolue then Continue;
        GRT[li, co].Candidats := GRT[li, co].Candidats - [Candi];
        ActuCElim(Li, Co);
        sCand := CandiToStr(GRT[li, co].Candidats);
        if length(sCand) = 1 then CandiToRes(sCand[1], Li, Co, clEffetDomino, Afficher);
      end;
    end;
  end;

begin
  GRT[li, co].ValReso := Candi;
  GRT[li, co].Info := ''; GRT[li, co].CElim := ''; GRT[li, co].CResu := '*';
  GRT[li, co].CoulCase := Coul;
  GRT[li, co].CaseResolue := TRUE; inc(NCRes);
  GRT[li, co].NumRes := NCRes;
  GRT[li, co].CResu := '*';
  if Afficher then AffCase(Candi, Li, Co);
  GRT[li, co].Candidats := [];
  ActuSetCandLignes(Li); ActuSetCandColonnes(Co); ActuSetCandBlocs(NumBloc(Li, Co));
end; // TSudoku.CandiToRes

function TSudoku.NbCasesAvecCandiEnLig(const Candi: char; const Li: byte): byte;
var Co: byte;
begin
  Result := 0;
  for Co := 1 to 9 do
    if Candi in GRT[Li, Co].Candidats then inc(Result);
end;

function TSudoku.NbCasesAvecCandiEnCol(const Candi: char; const Co: byte): byte;
var Li: byte;
begin
  Result := 0;
  for Li := 1 to 9 do
    if Candi in GRT[Li, Co].Candidats then inc(Result);
end;

function TSudoku.NbCasesAvecCandiEnBloc(const Candi: char; const Bloc: byte): byte;
var Lib, CoB, Li, Co: byte;
begin
  Result := 0;
  for LiB := 1 to 3 do begin
    for CoB := 1 to 3 do begin
      LiCoDeLiBlocCoBloc(Bloc, LiB, CoB, Li, Co);
      if Candi in GRT[Li, Co].Candidats then inc(Result);
    end;
  end;
end;

function TSudoku.OccPosCandLi(const Candi: char; const Li: byte; var Posit: TPositions): byte;
var Co: byte;
begin
  Result := 0; SetLength(Posit, 0);
  for Co := 1 to 9 do
    if Candi in GRT[Li, Co].Candidats then begin
      inc(Result); SetLength(Posit, Result);
      Posit[Result - 1].Cand := [Candi]; Posit[Result - 1].Li := Li; Posit[Result - 1].Co := Co;
    end;
end;

function TSudoku.OccPosCandCo(const Candi: char; const Co: byte; var Posit: TPositions): byte;
var Li: byte;
begin
  Result := 0; SetLength(Posit, 0);
  for Li := 1 to 9 do
    if Candi in GRT[Li, Co].Candidats then begin
      inc(Result); SetLength(Posit, Result);
      Posit[Result - 1].Cand := [Candi]; Posit[Result - 1].Li := Li; Posit[Result - 1].Co := Co;
    end;
end;

function TSudoku.OccPosCandBloc(const Candi: char; const Bloc: byte; var Posit: TPositions): byte;
var Lib, CoB, Li, Co: byte;
begin
  Result := 0; SetLength(Posit, 0);
  for LiB := 1 to 3 do begin
    for CoB := 1 to 3 do begin
      LiCoDeLiBlocCoBloc(Bloc, LiB, CoB, Li, Co);
      if Candi in GRT[Li, Co].Candidats then begin
        inc(Result); SetLength(Posit, Result);
        Posit[Result - 1].Cand := [Candi]; Posit[Result - 1].Li := Li; Posit[Result - 1].Co := Co;
      end;
    end;
  end;
end;

function TSudoku.OccPosCandisLi(const Candis: tSetOC; const Li: byte; var Posit: TPositions): byte;
var Co: byte;
begin
  Result := 0; SetLength(Posit, 0);
  for Co := 1 to 9 do
    if Candis * GRT[Li, Co].Candidats = Candis then begin
      inc(Result); SetLength(Posit, Result); Posit[Result - 1].Li := Li; Posit[Result - 1].Co := Co;
    end;
end;

function TSudoku.OccPosCandisCo(const Candis: tSetOC; const Co: byte; var Posit: TPositions): byte;
var Li: byte;
begin
  Result := 0; SetLength(Posit, 0);
  for Li := 1 to 9 do
    if Candis * GRT[Li, Co].Candidats = Candis then begin
      inc(Result); SetLength(Posit, Result); Posit[Result - 1].Li := Li; Posit[Result - 1].Co := Co;
    end;
end;

function TSudoku.OccPosCandisBloc(const Candis: tSetOC; const Bloc: byte; var Posit: TPositions): byte;
var Lib, CoB, Li, Co: byte;
begin
  Result := 0; SetLength(Posit, 0);
  for LiB := 1 to 3 do begin
    for CoB := 1 to 3 do begin
      LiCoDeLiBlocCoBloc(Bloc, LiB, CoB, Li, Co);
      if Candis * GRT[Li, Co].Candidats = Candis then begin
        inc(Result); SetLength(Posit, Result); Posit[Result - 1].Li := Li; Posit[Result - 1].Co := Co;
      end;
    end;
  end;
end;

function TSudoku.OccPosCandisNus(const DansLCouB: char; const Candis: tSetOC; const LCouB: byte; var Posit: TPositions): byte;
var Li, Co, LiB, CoB: byte;
begin
  Result := 0; SetLength(Posit, 0);
  case DansLCouB of
    'L': begin
        for Co := 1 to 9 do
          if GRT[LCouB, Co].Candidats = Candis then begin
            inc(Result); SetLength(Posit, Result); Posit[Result - 1].Li := LCouB; Posit[Result - 1].Co := Co;
          end;
      end;
    'C': begin
        for Li := 1 to 9 do
          if GRT[Li, LCouB].Candidats = Candis then begin
            inc(Result); SetLength(Posit, Result); Posit[Result - 1].Li := Li; Posit[Result - 1].Co := LCouB;
          end;
      end;
    'B': begin
        for LiB := 1 to 3 do begin
          for CoB := 1 to 3 do begin
            LiCoDeLiBlocCoBloc(LCouB, LiB, CoB, Li, Co);
            if GRT[Li, Co].Candidats = Candis then begin
              inc(Result); SetLength(Posit, Result); Posit[Result - 1].Li := Li; Posit[Result - 1].Co := Co;
            end;
          end;
        end;
      end;
  end;
end;

function TSudoku.OccPosCandisGrappe(const Candis: tSetOC; var Posit: TPositions): byte;
var Li, Co: byte;
begin
  Result := 0;
  SetLength(Posit, Result);
  for Li := 1 to 9 do begin
    for Co := 1 to 9 do begin
      if GRT[Li, Co].Candidats * Candis = Candis then begin
        inc(Result); SetLength(Posit, Result); Posit[Result - 1].Cand := GRT[Li, Co].Candidats;
        Posit[Result - 1].Li := Li; Posit[Result - 1].Co := Co;
      end;
    end;
  end;
end;

function TSudoku.EmplaOuCandiUniqueEn(const Li, Co: byte; var Candi: char): string;
var sCand: string; i, Bloc, OccLi, OccCo, OccBlo: byte;
begin
  Result := ''; Bloc := NumBloc(Li, Co);
  if GRT[Li, Co].CaseResolue then EXIT;
  sCand := CandiToStr(GRT[Li, Co].Candidats);
  if length(sCand) = 1 then begin // Candi = Unique
    Candi := sCand[1];
    Result := Format('Candidat %s = Rsulat pour L%dC%d car Unique dans cette case', [Candi, Li, Co]);
    GRT[Li, Co].Info := Result; GRT[Li, Co].CResu := Candi;
    EXIT;
  end;
  for i := 1 to length(sCand) do begin
    OccLi := NbCasesAvecCandiEnLig(sCand[i], Li);
    if (OccLi = 1) then begin
      Candi := sCand[i];
      Result := Format('Candidat %s = Rsulat pour L%dC%d car en Emplacement unique sur Ligne', [Candi, Li, Co]);
      GRT[Li, Co].Info := Result; GRT[Li, Co].CResu := Candi;
      EXIT;
    end;
    OccCo := NbCasesAvecCandiEnCol(sCand[i], Co);
    if (OccCo = 1) then begin
      Candi := sCand[i];
      Result := Format('Candidat %s = Rsulat pour L%dC%d car en Emplacement unique sur Colonne', [Candi, Li, Co]);
      GRT[Li, Co].Info := Result; GRT[Li, Co].CResu := Candi;
      EXIT;
    end;
    OccBlo := NbCasesAvecCandiEnBloc(sCand[i], Bloc);
    if (OccBlo = 1) then begin
      Candi := sCand[i];
      Result := Format('Candidat %s = Rsulat pour L%dC%d car en Emplacement unique dans Bloc %d', [Candi, Li, Co, Bloc]);
      GRT[Li, Co].Info := Result; GRT[Li, Co].CResu := Candi;
      EXIT;
    end;
  end;
end;

function TSudoku.ResolAvecEmplaOuCandiUnique(Afficher: boolean): boolean;
var Li, Co: byte; Candi: char;
begin
  Couleur := clResLogique;
  Result := false;
  for Li := 1 to 9 do begin
    for Co := 1 to 9 do begin
      if GRT[Li, Co].CaseResolue then Continue;
      if EmplaOuCandiUniqueEn(Li, Co, Candi) <> '' then begin
        Result := true; CandiToRes(Candi, Li, Co, Couleur, Afficher);
      end;
    end;
  end;
  if Result then ResolAvecEmplaOuCandiUnique(Afficher); // Appel rcursif
  if ControleRes = 'Contrle : OK' then begin
    GrilleResolue := true; EXIT;
  end
end;

function TSudoku.EmplaJumeauxEnLi(const Li: byte; var Candi: char; var Posit: TPositions): boolean;
var sCand: string; i, Occ, np: byte; SC: tSetOC; P: TPositions;
begin
  Result := False; np := 0; SetLength(Posit, 0);
  SC := GetCandLi(Li);
  sCand := CandiToStr(SC);
  for i := 1 to length(sCand) do begin
    Occ := OccPosCandLi(sCand[i], Li, P);
    if Occ = 2 then begin
      Result := True; inc(np, 2); SetLength(Posit, np);
      Posit[np - 2].Cand := P[0].Cand; Posit[np - 2].Li := P[0].Li; Posit[np - 2].Co := P[0].Co;
      Posit[np - 1].Cand := P[1].Cand; Posit[np - 1].Li := P[1].Li; Posit[np - 1].Co := P[1].Co;
      Candi := CandiToStr(P[0].Cand)[1];
      if (P[0].Li < 1) or (P[0].Li > 9) or (P[1].Li < 1) or (P[1].Li > 9) then sms(' bug en EmplaJumeauxEnLi');
    end;
  end;
end;

function TSudoku.IDEmplaJumeauxEnLi(const Li: byte; var Ejum: TEmplaJumeaux): boolean;
var sCand: string; i, Occ, np: byte; SC: tSetOC; P: TPositions;
begin
  Result := False; np := 0; SetLength(Ejum, 0);
  SC := GetCandLi(Li);
  sCand := CandiToStr(SC);
  for i := 1 to length(sCand) do begin
    Occ := OccPosCandLi(sCand[i], Li, P);
    if Occ = 2 then begin
      Result := True; inc(np); SetLength(Ejum, np);
      Ejum[np - 1].J1.Cand := P[0].Cand; Ejum[np - 1].J1.Li := P[0].Li; Ejum[np - 1].J1.Co := P[0].Co;
      Ejum[np - 1].J2.Cand := P[1].Cand; Ejum[np - 1].J2.Li := P[1].Li; Ejum[np - 1].J2.Co := P[1].Co;
    end;
  end;
end; // TSudoku.IDEmplaJumeauxEnLi

function TSudoku.IDEmplaJumeauxEnCo(const Co: byte; var Ejum: TEmplaJumeaux): boolean;
var sCand: string; i, Occ, np: byte; SC: tSetOC; P: TPositions;
begin
  Result := False; np := 0; SetLength(Ejum, 0);
  SC := GetCandCo(Co);
  sCand := CandiToStr(SC);
  for i := 1 to length(sCand) do begin
    Occ := OccPosCandCo(sCand[i], Co, P);
    if Occ = 2 then begin
      Result := True; inc(np); SetLength(Ejum, np);
      Ejum[np - 1].J1.Cand := P[0].Cand; Ejum[np - 1].J1.Li := P[0].Li; Ejum[np - 1].J1.Co := P[0].Co;
      Ejum[np - 1].J2.Cand := P[1].Cand; Ejum[np - 1].J2.Li := P[1].Li; Ejum[np - 1].J2.Co := P[1].Co;
    end;
  end;
end; // TSudoku.IDEmplaJumeauxEnCo

function TSudoku.IDEmplaJumeauxEnBloc(const Bloc: byte; var Ejum: TEmplaJumeaux): boolean;
var sCand: string; i, Occ, np: byte; SC: tSetOC; P: TPositions;
begin
  Result := False; np := 0; SetLength(Ejum, 0);
  SC := GetCandBloc(Bloc);
  sCand := CandiToStr(SC);
  for i := 1 to length(sCand) do begin
    Occ := OccPosCandBloc(sCand[i], Bloc, P);
    if Occ = 2 then begin
      Result := True; inc(np); SetLength(Ejum, np);
      Ejum[np - 1].J1.Cand := P[0].Cand; Ejum[np - 1].J1.Li := P[0].Li; Ejum[np - 1].J1.Co := P[0].Co;
      Ejum[np - 1].J2.Cand := P[1].Cand; Ejum[np - 1].J2.Li := P[1].Li; Ejum[np - 1].J2.Co := P[1].Co;
    end;
  end;
end; // TSudoku.IDEmplaJumeauxEnBloc

function TSudoku.EmplaJumeauxEnCo(const Co: byte; var Candi: char; var Posit: TPositions): boolean;
var sCand: string; i, Occ, np: byte; SC: tSetOC; P: TPositions;
begin
  Result := False; np := 0; SetLength(Posit, 0);
  SC := GetCandCo(Co);
  sCand := CandiToStr(SC);
  for i := 1 to length(sCand) do begin
    Occ := OccPosCandCo(sCand[i], Co, P);
    if Occ = 2 then begin
      Result := True; inc(np, 2); SetLength(Posit, np);
      Posit[np - 2].Cand := P[0].Cand; Posit[np - 2].Li := P[0].Li; Posit[np - 2].Co := P[0].Co;
      Posit[np - 1].Cand := P[1].Cand; Posit[np - 1].Li := P[1].Li; Posit[np - 1].Co := P[1].Co;
      Candi := CandiToStr(P[0].Cand)[1];
    end;
  end;
end;

function TSudoku.EmplaJumeauxEnBloc(const Bloc: byte; var Candi: char; var Posit: TPositions): boolean;
//  Ne renvoie que des emplacements jumeaux inclins pour viter des doublons avec ceux renvoys par EmplaJumeauxEnCo et EmplaJumeauxEnLi
var sCand: string; i, Occ, np: byte; SC: tSetOC; P: TPositions;
begin
  Result := False; np := 0; SetLength(Posit, 0);
  SC := GetCandBloc(Bloc);
  sCand := CandiToStr(SC);
  for i := 1 to length(sCand) do begin
    Occ := OccPosCandBloc(sCand[i], Bloc, P);
    if (Occ = 2) then begin
      if MemeLig(P[0], P[1]) or MemeCol(P[0], P[1]) then Continue;
      Result := True; inc(np, 2); SetLength(Posit, np);
      Posit[np - 2].Cand := P[0].Cand; Posit[np - 2].Li := P[0].Li; Posit[np - 2].Co := P[0].Co;
      Posit[np - 1].Cand := P[1].Cand; Posit[np - 1].Li := P[1].Li; Posit[np - 1].Co := P[1].Co;
    end;
  end;
end; // TSudoku.EmplaJumeauxEnBloc

function TSudoku.RepererElimInteractBloques: boolean;
label Recomm;
var GrilleNormale, OKElim: boolean; Cand: char; Blo, Li, nbElim: byte;
  Raison: shortString;

  function CandiSurUneSeuleLi(const Candi: char; const B: byte): byte;
  var LB, CB, Li, Co, occ: byte;
  begin
    Result := 0; occ := 0;
    for LB := 1 to 3 do begin
      for CB := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(B, LB, CB, Li, Co);
        if Candi in GRT[Li, Co].Candidats then begin
          if Li <> Result then begin
            inc(Occ); Result := Li;
          end;
        end;
      end;
    end;
    if occ <> 1 then Result := 0;
  end;

  procedure BaliserCaseElim(const cElim: char; const L, C: byte; const Raison: shortString);
  begin
    if cElim in GRT[L, C].Candidats then begin
      GRT[L, C].CElim := cElim; inc(nbElim); OKElim := true;
      if GrilleNormale
        then GRT[L, C].Info := Format('en L%dC%d car %s', [L, C, Raison])
      else GRT[L, C].Info := Format('en L%dC%d car %s', [C, L, Raison]);
    end;
  end;

  procedure BaliserElimLC1(const cElim: char; const SaufBloc, LiElim: byte);
  var Co, NumB: byte;
  begin
    if GrilleNormale then Raison := cElim + Format(' prsent dans Bloc %d uniquement sur ligne %d', [SaufBloc, LiElim])
    else Raison := cElim + Format(' prsent dans Bloc %d uniquement sur colonne %d', [NumBlocPerm(SaufBloc), LiElim]);
    for Co := 1 to 9 do begin
      NumB := NumBloc(LiElim, Co);
      if (NumB <> SaufBloc) then BaliserCaseElim(cElim, LiElim, Co, Raison);
    end;
  end;

  procedure InteractBlockedLC1(const B: byte);
  var ic, LiElim: byte; sCand: shortString; scb: tSetOC;
  begin
    scb := GetCandBloc(B);
    sCand := CandiToStr(scb);
    for ic := 1 to length(sCand) do begin
      Cand := sCand[ic];
      LiElim := CandiSurUneSeuleLi(Cand, B);
      if LiElim <> 0 then BaliserElimLC1(Cand, B, LiElim);
    end;
  end;

  function CandiSurLiDans1SeulBloc(const Candi: char; const L: byte): byte;
  var Co, Occ, BT: byte; B: array of byte;
  begin
    Result := 0; occ := 0; SetLength(B, occ);
    for Co := 1 to 9 do begin
      if Candi in GRT[Li, Co].Candidats then begin
        BT := NumBloc(Li, Co);
        if length(B) = 0 then begin
          inc(occ); SetLength(B, occ); B[occ - 1] := BT;
        end else begin
          if BT <> B[occ - 1] then begin
            inc(occ); SetLength(B, occ); B[occ - 1] := BT;
          end;
        end;
      end;
    end;
    if occ = 1 then Result := B[0];
  end;

  procedure BaliserElimLC2(const cElim: char; const SaufLi, BlocElim: byte);
  var LB, CB, Li, Co: byte;
  begin
    if GrilleNormale then Raison := cElim + Format(' prsent sur ligne %d uniquement dans Bloc %d', [SaufLi, BlocElim])
    else Raison := cElim + Format(' prsent sur colonne %d uniquement dans Bloc %d', [SaufLi, NumBlocPerm(BlocElim)]);
    for LB := 1 to 3 do begin
      for CB := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(BlocElim, LB, CB, Li, Co);
        if (Li <> SaufLi) then BaliserCaseElim(cElim, Li, Co, Raison);
      end;
    end;
  end;

  procedure InteractBlockedLC2(const L: byte);
  var ic, BlocElim: byte; sCand: shortString; scb: tSetOC;
  begin
    scb := GetCandLi(L);
    sCand := CandiToStr(scb);
    for ic := 1 to length(sCand) do begin
      Cand := sCand[ic];
      BlocElim := CandiSurLiDans1SeulBloc(Cand, L);
      if BlocElim <> 0 then BaliserElimLC2(Cand, L, BlocElim);
    end;
  end;

begin
  GrilleNormale := true; nbElim := 0;
  Recomm:
  for Blo := 1 to 9 do begin
    InteractBlockedLC1(Blo); // Interaction type LC1 : Si dans un bloc un candidat n'est prsent que sur une ligne ou colonne alors il est liminable hors bloc sur le reste de cette ligne ou colonne.
  end;
  for Li := 1 to 9 do begin
    InteractBlockedLC2(Li); // Interaction type LC2 : Si sur une ligne ou colonne un candidat n'est prsent que dans un seul bloc alors il est liminable dans le reste de ce bloc.
  end;
  if GrilleNormale then begin
    GRT := PermuterLiCo(Sudo.GRT); GrilleNormale := False;
    goto Recomm;
  end;
  GRT := PermuterLiCo(Sudo.GRT);
  result := nbElim > 0;
end; // TSudoku.RepererElimInteractBloques

function TSudoku.RepererChaineExclusion: boolean;
var Bloc, Li, Co, ic: byte; Cand: char;
  Ejm: TPositions; OKElim: boolean; strPosit: shortString;

  function EmplasJumeauxIncliEnBloc(const Candi: char; const Bloc: byte; var Ejum: TPositions): boolean;
  // Result = true si emplacements jumeaux inclins dans Bloc
  var Occ, np: byte; P: TPositions;
  begin
    Result := False; np := 0; SetLength(Ejum, 0);
    Occ := OccPosCandBloc(Candi, Bloc, P);
    if Occ = 2 then begin
      if (P[0].Li = P[1].Li) or (P[0].Co = P[1].Co) then EXIT;
      Result := True; inc(np, 2); SetLength(Ejum, np);
      Ejum[np - 2].Cand := P[0].Cand; Ejum[np - 2].Li := P[0].Li; Ejum[np - 2].Co := P[0].Co;
      Ejum[np - 1].Cand := P[1].Cand; Ejum[np - 1].Li := P[1].Li; Ejum[np - 1].Co := P[1].Co;
    end;
    if Result then strPosit := StrPositions(Ejum, True);
  end;

  function EmplasJumeauxEnChaine(const Candi: char; const EjumB: TPositions; var Li, Co: byte): boolean;
  var P: TPositions; L, C, occ: byte; s: shortString;
  begin
    Li := 0; Co := 0;
    L := EjumB[0].Li;
    Occ := OccPosCandLi(Candi, L, P);
    if occ = 2 then begin
      if (P[0].Co = EjumB[0].Co) then Co := P[1].Co;
      if (P[1].Co = EjumB[0].Co) then Co := P[0].Co;
      if Co <> 0 then s := Format(#13#10 + '- %s en L%dC%d', [Candi, L, Co]);
    end;
    C := EjumB[1].Co;
    Occ := OccPosCandCo(Candi, C, P);
    if occ = 2 then begin
      if (P[0].Li = EjumB[1].Li) then Li := P[1].Li;
      if (P[1].Li = EjumB[1].Li) then Li := P[0].Li;
      if Li <> 0 then s := s + Format(#13#10 + '- %s en L%dC%d', [Candi, Li, C]);
    end;
    Result := (Li <> 0) and (Co <> 0); if Result then begin strPosit := strPosit + s; EXIT; end;

    Li := 0; Co := 0;
    L := EjumB[1].Li;
    Occ := OccPosCandLi(Candi, L, P);
    if occ = 2 then begin
      if (P[0].Co = EjumB[1].Co) then Co := P[1].Co;
      if (P[1].Co = EjumB[1].Co) then Co := P[0].Co;
      if Co <> 0 then s := Format(#13#10 + '- %s en L%dC%d', [Candi, L, Co]);
    end;
    C := EjumB[0].Co;
    Occ := OccPosCandCo(Candi, C, P);
    if occ = 2 then begin
      if (P[0].Li = EjumB[0].Li) then Li := P[1].Li;
      if (P[1].Li = EjumB[0].Li) then Li := P[0].Li;
      if Li <> 0 then s := s + Format(#13#10 + '- %s en L%dC%d', [Candi, Li, C]);
    end;
    Result := (Li <> 0) and (Co <> 0);
    if Result then strPosit := strPosit + s;
  end;

  procedure BaliserCasesElim(const cElim: char; const Li, Co: byte);
  begin
    if cElim in GRT[Li, Co].Candidats then begin
      GRT[Li, Co].CElim := GRT[Li, Co].CElim + cElim; OKElim := true;
      GRT[Li, Co].Info := Format('en L%dC%d car chane d''exclusion avec %s', [Li, Co, StrPosit]);
    end;
  end;

begin
  OKElim := false;
  for ic := 49 to 57 do begin
    Cand := chr(ic);
    for Bloc := 1 to 9 do begin
      if EmplasJumeauxIncliEnBloc(Cand, Bloc, Ejm)
        and EmplasJumeauxEnChaine(Cand, Ejm, Li, Co)
        then BaliserCasesElim(Cand, Li, Co);
    end;
  end;
  Result := OKElim;
end; // TSudoku.RepererChaineExclusion

function TSudoku.RepererElimParXWing: boolean;
label Recomm;
var ic, Li, Bloc1, Bloc2, occ, n, nbElim: byte; Cand: char; Po2, PoN, Po4: TPositions;
  Raiso: shortString; RectOuTrapeze: char;
  OKElim: boolean; StrPosit: string; nbXWings: integer;
  GrilleNormale: boolean; // Grille non permute
  Config: tConfig; AliBlocs: char;

  function EstXWingLiCo(const PoN: Tpositions; var Po4: tPositions; var RectOuTrapeze: char; var B1, B2: byte): boolean;
  var i, j, L1, L2, C1, C2, C3, C4, B3, B4: byte;
  begin
    Result := false; if length(PoN) < 2 then EXIT;
    SetLength(Po4, 0);
    // XWing-Rectangle ? :
    i := 0;
    repeat
      L1 := PoN[i].Li; C1 := PoN[i].Co; C2 := PoN[i + 1].Co;
      j := i + 2;
      repeat
        L2 := PoN[j].Li; C3 := PoN[j].Co; C4 := PoN[j + 1].Co;
        if (C1 = C3) and (C2 = C4) then begin
          RectOuTrapeze := 'R'; Result := true;
        end;
        if Result then begin
          SetLength(Po4, 4);
          Po4[0].Cand := PoN[i].Cand; Po4[0].Li := L1; Po4[0].Co := C1;
          Po4[1].Cand := PoN[i].Cand; Po4[1].Li := L1; Po4[1].Co := C2;
          Po4[2].Cand := PoN[i].Cand; Po4[2].Li := L2; Po4[2].Co := C3;
          Po4[3].Cand := PoN[i].Cand; Po4[3].Li := L2; Po4[3].Co := C4;
          if cand = '4' then Trace('St ' + strPositions(Po4, GrilleNormale));
          EXIT;
        end;
        inc(j, 2);
      until j >= length(PoN) - 1;
      inc(i, 2);
    until i >= length(PoN) - 1;
    // Sinon XWing-Trapze ? :
    i := 0;
    repeat
      L1 := PoN[i].Li; C1 := PoN[i].Co; C2 := PoN[i + 1].Co;
      B1 := NumBloc(L1, C1); B2 := NumBloc(L1, C2);
      j := i + 2;
      repeat
        L2 := PoN[j].Li; C3 := PoN[j].Co; C4 := PoN[j + 1].Co;
        B3 := NumBloc(L2, C3); B4 := NumBloc(L2, C4);
        if (B1 = B3) and (B2 = B4) then begin
          RectOuTrapeze := 'T'; Result := true;
        end;
        if Result then begin
          SetLength(Po4, 4);
          Po4[0].Cand := PoN[i].Cand; Po4[0].Li := L1; Po4[0].Co := C1;
          Po4[1].Cand := PoN[i].Cand; Po4[1].Li := L1; Po4[1].Co := C2;
          Po4[2].Cand := PoN[i].Cand; Po4[2].Li := L2; Po4[2].Co := C3;
          Po4[3].Cand := PoN[i].Cand; Po4[3].Li := L2; Po4[3].Co := C4;
          EXIT;
        end;
        inc(j, 2);
      until j >= length(PoN) - 1;
      inc(i, 2);
    until i >= length(PoN) - 1;
  end; // EstXWingLiCo

  procedure BaliserCaseElim(const cElim: char; const L, C: byte; const Raison: shortString);
  var SAli: string;
  begin
    case RectOuTrapeze of
      'R': SAli := '-Rectangle';
      'T': SAli := '-Trapze';
      'H': SAli := '-H';
      'V': SAli := '-V';
    end;
    if cElim in GRT[L, C].Candidats then begin
      GRT[L, C].CElim := cElim; inc(nbElim); OKElim := true;
      if GrilleNormale
        then GRT[L, C].Info := Format('en L%dC%d car %s avec : %s', [L, C, Raison + SAli, StrPosit])
      else GRT[L, C].Info := Format('en L%dC%d car %s avec : %s', [C, L, Raison + SAli, StrPosit]);
    end;
  end;

  procedure BaliserElimDansCoOuBloc(const Po4: tPositions; const RectOuTrapeze: char; const B1, B2: byte);
  var Li, Co, LiB, CoB, L1, L2, C1, C2, C3, C4: byte;
  begin
    if GrilleNormale then StrPosit := StrPositions(Po4, TRUE) else StrPosit := StrPositions(Po4, FALSE);
    L1 := Po4[0].Li; L2 := Po4[2].Li;
    C1 := Po4[0].Co; C2 := Po4[1].Co; C3 := Po4[2].Co; C4 := Po4[3].Co;
    if (RectOuTrapeze = 'R') then begin
      Co := C1; for Li := 1 to 9 do if (Li <> L1) and (Li <> L2) then BaliserCaseElim(Cand, Li, Co, Raiso);
      Co := C2; for Li := 1 to 9 do if (Li <> L1) and (Li <> L2) then BaliserCaseElim(Cand, Li, Co, Raiso);
      Co := C3; for Li := 1 to 9 do if (Li <> L1) and (Li <> L2) then BaliserCaseElim(Cand, Li, Co, Raiso);
      Co := C4; for Li := 1 to 9 do if (Li <> L1) and (Li <> L2) then BaliserCaseElim(Cand, Li, Co, Raiso);
      EXIT;
    end;
    if RectOuTrapeze = 'T' then begin
      for Lib := 1 to 3 do begin // Elim dans B1 :
        for Cob := 1 to 3 do begin
          LiCoDeLiBlocCoBloc(B1, LiB, CoB, Li, Co);
          if ((Li = L1) and (Co = C1)) or ((Li = L2) and (Co = C3)) then Continue;
          BaliserCaseElim(Cand, Li, Co, Raiso);
        end;
      end;
      for Lib := 1 to 3 do begin // Elim dans B2 :
        for Cob := 1 to 3 do begin
          LiCoDeLiBlocCoBloc(B2, LiB, CoB, Li, Co);
          if ((Li = L1) and (Co = C2)) or ((Li = L2) and (Co = C4)) then Continue;
          BaliserCaseElim(Cand, Li, Co, Raiso);
        end;
      end;
    end;
  end;

  function IDEmplaJumeauxEnBloc2(const Candi: char; const Bloc: byte; var Ejum: TPositions): boolean;
  var Occ, np: byte; P: TPositions;
  begin
    Result := False; np := 0; SetLength(Ejum, 0);
    Occ := OccPosCandBloc(Candi, Bloc, P);
    if Occ = 2 then begin
      Result := True; inc(np, 2); SetLength(Ejum, np);
      Ejum[np - 2].Cand := P[0].Cand; Ejum[np - 2].Li := P[0].Li; Ejum[np - 2].Co := P[0].Co;
      Ejum[np - 1].Cand := P[1].Cand; Ejum[np - 1].Li := P[1].Li; Ejum[np - 1].Co := P[1].Co;
    end;
  end; // IDEmplaJumeauxEnBloc2

  function EstXWingBloc(const Candi: char; var Po4: TPositions; var Ali: char): boolean;
  label SuiteVertical;
  var BlGH, BlocFin, k: byte; P1, P2, P3: TPositions; ok1, ok2, ok3: boolean;
  begin
    Result := False; SetLength(Po4, 0);
    Ali := 'H';
    SuiteVertical:
    BlGH := 1; k := 1; BlocFin := 7;
    case Ali of
      'H': begin k := 1; BlocFin := 7; end;
      'V': begin k := 3; BlocFin := 3; end;
    end;
    repeat
      // NumBloc : H => 123  puis V => 147
      //                456            258
      //                789            369
      ok1 := IDEmplaJumeauxEnBloc2(Candi, BlGH, P1);
      ok2 := IDEmplaJumeauxEnBloc2(Candi, BlGH + 1 * k, P2);
      ok3 := IDEmplaJumeauxEnBloc2(Candi, BlGH + 2 * k, P3);
      if ok1 and ok2 and DeuxAlignes(P1[0], P2[0]) and DeuxAlignes(P1[1], P2[1]) then begin
        Result := True; SetLength(Po4, 4);
        Po4[0].Cand := P1[0].Cand; Po4[0].Li := P1[0].Li; Po4[0].Co := P1[0].Co;
        Po4[1].Cand := P1[1].Cand; Po4[1].Li := P1[1].Li; Po4[1].Co := P1[1].Co;

        Po4[2].Cand := P2[0].Cand; Po4[2].Li := P2[0].Li; Po4[2].Co := P2[0].Co;
        Po4[3].Cand := P2[1].Cand; Po4[3].Li := P2[1].Li; Po4[3].Co := P2[1].Co;
        RectOuTrapeze := Ali; EXIT;
      end;
      if ok1 and ok3 and DeuxAlignes(P1[0], P3[0]) and DeuxAlignes(P1[1], P3[1]) then begin
        Result := True; SetLength(Po4, 4);
        Po4[0].Cand := P1[0].Cand; Po4[0].Li := P1[0].Li; Po4[0].Co := P1[0].Co;
        Po4[1].Cand := P1[1].Cand; Po4[1].Li := P1[1].Li; Po4[1].Co := P1[1].Co;

        Po4[2].Cand := P3[0].Cand; Po4[2].Li := P3[0].Li; Po4[2].Co := P3[0].Co;
        Po4[3].Cand := P3[1].Cand; Po4[3].Li := P3[1].Li; Po4[3].Co := P3[1].Co;
        RectOuTrapeze := Ali; EXIT;
      end;
      if ok2 and ok3 and DeuxAlignes(P2[0], P3[0]) and DeuxAlignes(P2[1], P3[1]) then begin
        Result := True; SetLength(Po4, 4);
        Po4[0].Cand := P2[0].Cand; Po4[0].Li := P2[0].Li; Po4[0].Co := P2[0].Co;
        Po4[1].Cand := P2[1].Cand; Po4[1].Li := P2[1].Li; Po4[1].Co := P2[1].Co;

        Po4[2].Cand := P3[0].Cand; Po4[2].Li := P3[0].Li; Po4[2].Co := P3[0].Co;
        Po4[3].Cand := P3[1].Cand; Po4[3].Li := P3[1].Li; Po4[3].Co := P3[1].Co;
        RectOuTrapeze := Ali; EXIT;
      end;
      if k = 1 then inc(BlGH, 3) else inc(BlGH);
    until BlGH > BlocFin;
    if Ali = 'H' then begin Ali := 'V'; goto SuiteVertical; end;
  end; // EstXWingBloc

  procedure BaliserElimXWingBloc(const Po4: tPositions; const Ali: char);
  var Li, Co, L1, L2, L3, L4, C1, C2, C3, C4: byte;
  begin
    if GrilleNormale then StrPosit := StrPositions(Po4, TRUE) else StrPosit := StrPositions(Po4, FALSE);
    case Ali of
      'H': begin
          L1 := Po4[0].Li; L2 := Po4[1].Li;
          C1 := Po4[0].Co; C2 := Po4[1].Co; C3 := Po4[2].Co; C4 := Po4[3].Co;
          Li := L1; for Co := 1 to 9 do if (Co <> C1) and (Co <> C2) and (Co <> C3) and (Co <> C4) then BaliserCaseElim(Cand, Li, Co, Raiso);
          Li := L2; for Co := 1 to 9 do if (Co <> C1) and (Co <> C2) and (Co <> C3) and (Co <> C4) then BaliserCaseElim(Cand, Li, Co, Raiso);
        end;
      'V': begin
          C1 := Po4[0].Co; C2 := Po4[1].Co;
          L1 := Po4[0].Li; L2 := Po4[1].Li; L3 := Po4[2].Li; L4 := Po4[3].Li;
          Co := C1; for Li := 1 to 9 do if (Li <> L1) and (Li <> L2) and (Li <> L3) and (Li <> L4) then BaliserCaseElim(Cand, Li, Co, Raiso);
          Co := C2; for Li := 1 to 9 do if (Li <> L1) and (Li <> L2) and (Li <> L3) and (Li <> L4) then BaliserCaseElim(Cand, Li, Co, Raiso);
        end;
    end;
  end;

begin
  nbElim := 0; Raiso := 'XWing-Lignes';
  Config := cXWingLig; nbXWings := -1; GrilleNormale := True;
  Recomm:
  for ic := 49 to 57 do begin
    Cand := Chr(ic); n := 0; SetLength(PoN, n);
    if Config <> cXWingBlo then begin
       // Emplas jum sur Lignes :
      for Li := 1 to 9 do begin
        occ := OccPosCandLi(Cand, Li, Po2);
        if (Occ = 2) then begin
          inc(n, 2); SetLength(PoN, n);
          PoN[n - 2].Cand := Po2[0].Cand; PoN[n - 2].Li := Po2[0].Li; PoN[n - 2].Co := Po2[0].Co;
          PoN[n - 1].Cand := Po2[1].Cand; PoN[n - 1].Li := Po2[1].Li; PoN[n - 1].Co := Po2[1].Co;
        end;
      end; // for Li := 1 to 9
      if length(PoN) < 4 then Continue;
      if EstXWingLiCo(PoN, Po4, RectOuTrapeze, Bloc1, Bloc2) then begin // XWing-Lignes
        OKElim := false;
        BaliserElimDansCoOuBloc(Po4, RectOuTrapeze, Bloc1, Bloc2);
        if OKElim then begin
          inc(nbXWings);
          if length(Po4) = 4 then Reperer(Po4, clFondG(nbXWings), []);
        end;
      end;
    end;
    if Config = cXWingBlo then begin // XWing-Bloc
      if not EstXWingBloc(Cand, Po4, AliBlocs) then Continue;
      OKElim := false;
      BaliserElimXWingBloc(Po4, AliBlocs);
      if OKElim then begin
        inc(nbXWings);
        if length(Po4) = 4 then Reperer(Po4, clFondG(nbXWings), []);
      end;
    end;
  end; // for ic
  if (Config = cXWingLig) and GrilleNormale then begin
    Raiso := 'XWing-Colonnes'; Config := cXWingCol;
    GRT := PermuterLiCo(Sudo.GRT); GrilleNormale := False;
    goto Recomm;
  end;
  if (Config = cXWingCol) and (GrilleNormale = False) then begin
    GRT := PermuterLiCo(Sudo.GRT);
    Raiso := 'XWing-Blocs'; Config := cXWingBlo; GrilleNormale := True;
    goto Recomm;
  end;
  Result := nbElim <> 0;
end; //TSudoku.RepererElimParXWing

function TSudoku.RepererElimParInterActBlocs: boolean;
label Recomm;
type tAB12 = array[1..3] of byte;
var ic, nbElim: byte; Cand: char; Raison, sInter: shortString; OKElim: boolean;
  GrilleNormale: boolean; // Grille non permute

  function IDCandiPresentDansBlocsSurLi(const Candi: char; const Bloc1, Bloc2: byte; var BlocElim2, LA, LB, OccB1, OccB2: byte): boolean;
var LiB, CoB, Li, Co, i: byte; var LP1, LP2: tAB12;
  begin
    OccB1 := 0; Result := false; LA := 0; LB := 0; BlocElim2 := 0;
    for i := 1 to 3 do begin LP1[i] := 0; LP2[i] := 0; end;
    for LiB := 1 to 3 do begin
      for CoB := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(Bloc1, LiB, CoB, Li, Co);
        if Candi in GRT[Li, Co].Candidats then begin
          if Li <> LP1[OccB1] then begin inc(OccB1); LP1[OccB1] := Li; end;
        end;
      end;
    end;
    OccB2 := 0;
    for LiB := 1 to 3 do begin
      for CoB := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(Bloc2, LiB, CoB, Li, Co);
        if Candi in GRT[Li, Co].Candidats then begin
          if Li <> LP2[OccB2] then begin inc(OccB2); LP2[OccB2] := Li; end;
        end;
      end;
    end;

    if (OccB1 = 0) or (OccB2 = 0) or (OccB1 = 3) or (OccB2 = 3) or ((OccB1 = 1) and (OccB2 = 1)) then EXIT;
    if OccB1 = 1 then begin
      BlocElim2 := Bloc2; LA := LP1[1];
      if OccB2 = 2 then begin
        if LP2[1] = LA then begin LB := LP2[2]; Result := true; end else
          if LP2[2] = LA then begin LB := LP2[1]; Result := true; end;
        if Result then begin
          if GrilleNormale then sInter := Candi + Format(' du Bloc %d group(s) sur L%d', [Bloc1, LA])
          else sInter := Candi + Format(' du Bloc %d group(s) sur C%d', [NumBlocPerm(Bloc1), LA]);
        end;
      end;
    end else
      if (OccB2 = 1) then begin
      BlocElim2 := Bloc1; LA := LP2[1];
      if OccB1 = 2 then begin
        if LP1[1] = LA then begin LB := LP1[2]; Result := true; end else
          if LP1[2] = LA then begin LB := LP1[1]; Result := true; end;
        if Result then begin
          if GrilleNormale then sInter := Candi + Format(' du Bloc %d group(s) sur L%d', [Bloc2, LA])
          else sInter := Candi + Format(' du Bloc %d group(s) sur C%d', [NumBlocPerm(Bloc2), LA]);
        end;
      end;
    end;
    if (OccB1 = 2) and (OccB2 = 2) then begin
      if (LP1[1] = LP2[1]) and (LP1[2] = LP2[2]) then begin LA := LP1[1]; LB := LP1[2]; Result := true; end;
      if Result then begin
        if GrilleNormale then sInter := Candi + Format(' des Blocs B%d,B%d groups sur les deux mmes lignes L%d,L%d', [Bloc1, Bloc2, LA, LB])
        else sInter := Candi + Format(' des Blocs %d,%d groups sur les deux mmes colonnes C%d,C%d', [NumBlocPerm(Bloc1), NumBlocPerm(Bloc2), LA, LB]);
      end;
    end;
  end; // IDCandiPresentDansBlocsSurLi

  procedure BaliserCaseElim(const cElim: char; const L, C: byte; const Raison: shortString);
  begin
    if cElim in GRT[L, C].Candidats then begin
      GRT[L, C].CElim := cElim; inc(nbElim); OKElim := true;
      if GrilleNormale then GRT[L, C].Info := Format('en L%dC%d car %s', [L, C, Raison])
      else GRT[L, C].Info := Format('en L%dC%d car %s', [C, L, Raison])
    end;
  end;

  procedure BaliserElim(const Candi: char; const LA, LB, B2, B3: byte);
  var L, C: byte;
  begin
    L := LA; for C := 1 to 9 do if NumBloc(L, C) = B3 then BaliserCaseElim(Candi, L, C, Raison + sInter);
    L := LB; for C := 1 to 9 do if NumBloc(L, C) = B3 then BaliserCaseElim(Candi, L, C, Raison + sInter);
    if B2 <> 0 then begin
      L := LA; for C := 1 to 9 do if NumBloc(L, C) = B2 then BaliserCaseElim(Candi, L, C, Raison + sInter);
    end;
  end;

  function InteractionBlocs(const Candi: char): boolean;
  label SuiteVertical;
  var BlGH, BlocFin, k, B1, B2, B3: byte; ok12, ok13, ok23: boolean;
    OccLi1, OccLi2: byte;
    BlocElim2, BlocElim3: byte; LA, LB: byte;
  begin
    Result := False;
    BlGH := 1; k := 1; BlocFin := 7;
    repeat
      // NumBloc : H => 123
      //                456
      //                789
      B1 := BlGH; B2 := B1 + 1 * k; B3 := B1 + 2 * k;
      ok12 := IDCandiPresentDansBlocsSurLi(Candi, B1, B2, BlocElim2, LA, LB, OccLi1, OccLi2);

      if ok12 then begin
        Result := true; BlocElim3 := B3;
        BaliserElim(Candi, LA, LB, BlocElim2, BlocElim3);
      end;
      ok13 := IDCandiPresentDansBlocsSurLi(Candi, B1, B3, BlocElim2, LA, LB, OccLi1, OccLi2);
      if ok13 then begin
        Result := true; BlocElim3 := B2;
        BaliserElim(Candi, LA, LB, BlocElim2, BlocElim3);
      end;
      ok23 := IDCandiPresentDansBlocsSurLi(Candi, B2, B3, BlocElim2, LA, LB, OccLi1, OccLi2);
      if ok23 then begin
        Result := true; BlocElim3 := B1;
        BaliserElim(Candi, LA, LB, BlocElim2, BlocElim3);
      end;
      inc(BlGH, 3);
    until BlGH > BlocFin;
  end; // InteractionBlocs

begin
  GrilleNormale := true; nbElim := 0; Raison := 'Interactions entre Blocs vu ';
  Recomm:
  for ic := 49 to 57 do begin
    Cand := Chr(ic);
    InteractionBlocs(Cand);
  end;
  if GrilleNormale then begin
    GRT := PermuterLiCo(Sudo.GRT); GrilleNormale := False;
    goto Recomm;
  end;
  GRT := PermuterLiCo(Sudo.GRT);
  result := nbElim > 0;
end; // TSudoku.RepererElimParInterActBlocs

function TSudoku.RepererElimParSwordFish: boolean;
label Recomm;
type TPosL = record Cand: tSetOC; Li: byte; Co: byte; occLiensCo: byte; end;
  TPositL = array of array of TPosL;
var ic, Li, occ, n, nPL, nbElim, nbSwords: byte; Candi: char; Po2, Po6: TPositions; PoN: TPositL;
  Raiso, TroisCol: shortString; OKElim: boolean; StrPosit: string; Config: tConfig;

  function VerifAliSur3LiEt3Co(const PoN: TPositL; var Po67: TPositions; var TroisCol: shortString): boolean;
  //  var TroisCol renvoie les 3 Col
  var l1, l2, jpl1, jpl2, i, j, Co, nl: byte; aliSurCol: boolean;
    setLi, setCo: tSetOC;
  begin
    for l1 := 0 to High(PoN) do begin
      for jpl1 := 0 to high(PoN[l1]) do begin
        Co := PoN[l1, jpl1].Co;
        for l2 := 0 to High(PoN) do begin
          for jpl2 := 0 to high(PoN[l2]) do begin
            if (PoN[l2, jpl2].Co = Co) then begin inc(PoN[l1, jpl1].occLiensCo); inc(PoN[l2, jpl2].occLiensCo); end;
          end;
        end;
      end;
    end;
    nl := 0; SetLength(Po67, nl);
    for i := 0 to High(PoN) do begin
      aliSurCol := true;
      for j := 0 to High(PoN[i]) do begin
        if PoN[i, j].occLiensCo = 2 then aliSurCol := false;
      end;
      if aliSurCol then begin
        for j := 0 to High(PoN[i]) do begin
          inc(nl); SetLength(Po67, nl);
          Po67[nl - 1].Cand := PoN[i, j].Cand;
          Po67[nl - 1].Li := PoN[i, j].Li; Po67[nl - 1].Co := PoN[i, j].Co;
        end;
      end;
    end;
    if length(Po67) = 0 then begin Result := false; EXIT; end;
    // Verif 3 Li 3 Co :
    setLi := []; setCo := [];
    for i := 0 to High(Po67) do begin
      setLi := setLi + [intToStr(Po67[i].Li)[1]];
      setCo := setCo + [intToStr(Po67[i].Co)[1]];
    end;
    TroisCol := CandiToStr(setCo);
    Result := (length(CandiToStr(setLi)) = 3) and (length(TroisCol) = 3);
  end;

  procedure BaliserCaseElim(const cElim: char; const L, C: byte; const Raison: shortString);
  begin
    if cElim in GRT[L, C].Candidats then begin
      GRT[L, C].CElim := cElim; inc(nbElim); OKElim := true;
      if Config = cSwordFCol then begin trace(Raison); GRT[L, C].Info := Format('en L%dC%d car %s <= SwirdFish n%d', [L, C, Raison, nbSwords]); end;
      if Config = cSwordFLig then begin trace(Raison); GRT[L, C].Info := Format('en L%dC%d car %s <= SwirdFish n%d', [C, L, Raison, nbSwords]); end;
    end;
  end;

  function CaseAEviter(const Li, Co: byte; const Po6: TPositions): boolean;
  var i: byte;
  begin
    Result := false;
    for i := 0 to High(Po6) do begin
      if (Po6[i].Li = Li) and (Po6[i].Co = Co) then begin
        Result := True; EXIT;
      end;
    end;
  end;

  procedure BaliserElimSurCo(const Po6: TPositions; TroisCol: shortString; const Raison: string);
  var i, Li, Co: byte;
  begin
    if length(TroisCol) <> 3 then EXIT;
    for i := 1 to 3 do begin
      Co := StrToInt(TroisCol[i]);
      for Li := 1 to 9 do begin
        if CaseAEviter(Li, Co, Po6) then Continue;
        BaliserCaseElim(Candi, Li, Co, Raison);
      end;
    end;
  end;

begin
  nbElim := 0; Raiso := 'Swordfish-Lignes-3x3';
  Config := cSwordFLig; nbSwords := 0;
  Recomm:
  for ic := 49 to 57 do begin
    Candi := Chr(ic);
    nPL := 0; SetLength(PoN, nPL);
    for Li := 1 to 9 do begin
      occ := OccPosCandLi(Candi, Li, Po2);
      if (occ < 2) or (occ > 3) then Continue;
      inc(nPL);
      SetLength(PoN, nPl); n := 0;
      if (Occ = 2) then begin
        inc(n, 2); SetLength(PoN[nPl - 1], n);
        PoN[nPl - 1, n - 2].occLiensCo := 0; PoN[nPl - 1, n - 2].Cand := Po2[0].Cand; PoN[nPl - 1, n - 2].Li := Po2[0].Li; PoN[nPl - 1, n - 2].Co := Po2[0].Co;
        PoN[nPl - 1, n - 1].occLiensCo := 0; PoN[nPl - 1, n - 1].Cand := Po2[1].Cand; PoN[nPl - 1, n - 1].Li := Po2[1].Li; PoN[nPl - 1, n - 1].Co := Po2[1].Co;
      end;
      if (Occ = 3) then begin
        inc(n, 3); SetLength(PoN[nPl - 1], n);
        PoN[nPl - 1, n - 3].occLiensCo := 0; PoN[nPl - 1, n - 3].Cand := Po2[0].Cand; PoN[nPl - 1, n - 3].Li := Po2[0].Li; PoN[nPl - 1, n - 3].Co := Po2[0].Co;
        PoN[nPl - 1, n - 2].occLiensCo := 0; PoN[nPl - 1, n - 2].Cand := Po2[1].Cand; PoN[nPl - 1, n - 2].Li := Po2[1].Li; PoN[nPl - 1, n - 2].Co := Po2[1].Co;
        PoN[nPl - 1, n - 1].occLiensCo := 0; PoN[nPl - 1, n - 1].Cand := Po2[2].Cand; PoN[nPl - 1, n - 1].Li := Po2[2].Li; PoN[nPl - 1, n - 1].Co := Po2[2].Co;
      end;
    end; // for Li := 1 to 9
    if (length(PoN) < 3) then Continue;
    if VerifAliSur3LiEt3Co(PoN, Po6, TroisCol) then begin
      if Config = cSwordFLig then StrPosit := StrPositions(Po6, TRUE) else StrPosit := StrPositions(Po6, FALSE);
      OKElim := false; inc(nbSwords);
      BaliserElimSurCo(Po6, TroisCol, Raiso + ' :' + StrPosit);
      if OKElim then begin
        Reperer(Po6, clFondG(nbSwords - 1), []);
      end;
    end;
  end; //for ic := 49
  if Config = cSwordFLig then begin
    Config := cSwordFCol; Raiso := 'Swordfish-Colonnes-3x3';
    GRT := PermuterLiCo(Sudo.GRT);
    goto Recomm;
  end;
  if Config = cSwordFCol then GRT := PermuterLiCo(Sudo.GRT);
  Result := nbElim <> 0;
end; // TSudoku.RepererElimParSwordFish

function TSudoku.RepererElimParJellyfish: boolean;
label Recomm;
type TPosL = record Cand: tSetOC; Li: byte; Co: byte; occLiensCo: byte; end;
  TPositL = array of array of TPosL;
var ic, Li, occ, n, nPL, nbElim, nbJellys: byte; Candi: char; Po2, Po6: TPositions; PoN: TPositL;
  Raiso, QuatreCol: shortString; OKElim: boolean; StrPosit: string; Config: tConfig;

  function VerifAliSur4LiEt4Co(const PoN: TPositL; var Po67: TPositions; var QuatreCol: shortString): boolean;
  //  var QuatreCol renvoie les 4 Col
  var l1, l2, jpl1, jpl2, i, j, Co, nl: byte; aliSurCol: boolean;
    setLi, setCo: tSetOC;
  begin
    for l1 := 0 to High(PoN) do begin
      for jpl1 := 0 to high(PoN[l1]) do begin
        Co := PoN[l1, jpl1].Co;
        for l2 := 0 to High(PoN) do begin
          for jpl2 := 0 to high(PoN[l2]) do begin
            if (PoN[l2, jpl2].Co = Co) then begin inc(PoN[l1, jpl1].occLiensCo); inc(PoN[l2, jpl2].occLiensCo); end;
          end;
        end;
      end;
    end;
    nl := 0; SetLength(Po67, nl);
    for i := 0 to High(PoN) do begin
      aliSurCol := true;
      for j := 0 to High(PoN[i]) do begin
        if PoN[i, j].occLiensCo = 2 then aliSurCol := false;
      end;
      if aliSurCol then begin
        for j := 0 to High(PoN[i]) do begin
          inc(nl); SetLength(Po67, nl);
          Po67[nl - 1].Cand := PoN[i, j].Cand;
          Po67[nl - 1].Li := PoN[i, j].Li; Po67[nl - 1].Co := PoN[i, j].Co;
        end;
      end;
    end;
    if length(Po67) = 0 then begin Result := false; EXIT; end; //sms('Bug 1');
    // Verif 4 Li 4 Co :
    setLi := []; setCo := [];
    for i := 0 to High(Po67) do begin
      setLi := setLi + [intToStr(Po67[i].Li)[1]];
      setCo := setCo + [intToStr(Po67[i].Co)[1]];
    end;
    QuatreCol := CandiToStr(setCo);
    Result := (length(CandiToStr(setLi)) = 4) and (length(QuatreCol) = 4);
  end;

  procedure BaliserCaseElim(const cElim: char; const L, C: byte; const Raison: shortString);
  begin
    if cElim in GRT[L, C].Candidats then begin
      GRT[L, C].CElim := cElim; inc(nbElim); OKElim := true;
      if Config = cJellyCol then begin trace(Raison); GRT[L, C].Info := Format('en L%dC%d car %s <= Jellyfish n%d', [L, C, Raison, nbJellys]); end;
      if Config = cJellyLig then begin trace(Raison); GRT[L, C].Info := Format('en L%dC%d car %s <= Jellyfish n%d', [C, L, Raison, nbJellys]); end;
    end;
  end;

  function CaseAEviter(const Li, Co: byte; const Po6: TPositions): boolean;
  var i: byte;
  begin
    Result := false;
    for i := 0 to High(Po6) do begin
      if (Po6[i].Li = Li) and (Po6[i].Co = Co) then begin
        Result := True; EXIT;
      end;
    end;
  end;

  procedure BaliserElimSurCo(const Po6: TPositions; QuatreCol: shortString; const Raison: string);
  var i, Li, Co: byte;
  begin
    if length(QuatreCol) <> 4 then EXIT;
    for i := 1 to 4 do begin
      Co := StrToInt(QuatreCol[i]);
      for Li := 1 to 9 do begin
        if CaseAEviter(Li, Co, Po6) then Continue;
        BaliserCaseElim(Candi, Li, Co, Raison);
      end;
    end;
  end;

begin
  nbElim := 0; Raiso := 'Jellyfish-Lignes-4x4';
  Config := cJellyLig; nbJellys := 0;
  Recomm:
  for ic := 49 to 57 do begin
    Candi := Chr(ic);
    nPL := 0; SetLength(PoN, nPL);
    for Li := 1 to 9 do begin

      occ := OccPosCandLi(Candi, Li, Po2);
      if (occ < 2) or (occ > 4) then Continue;
      inc(nPL);
      SetLength(PoN, nPl); n := 0;
      if (Occ = 2) then begin
        inc(n, 2); SetLength(PoN[nPl - 1], n);
        PoN[nPl - 1, n - 2].occLiensCo := 0; PoN[nPl - 1, n - 2].Cand := Po2[0].Cand; PoN[nPl - 1, n - 2].Li := Po2[0].Li; PoN[nPl - 1, n - 2].Co := Po2[0].Co;
        PoN[nPl - 1, n - 1].occLiensCo := 0; PoN[nPl - 1, n - 1].Cand := Po2[1].Cand; PoN[nPl - 1, n - 1].Li := Po2[1].Li; PoN[nPl - 1, n - 1].Co := Po2[1].Co;
      end;
      if (Occ = 3) then begin
        inc(n, 3); SetLength(PoN[nPl - 1], n);
        PoN[nPl - 1, n - 3].occLiensCo := 0; PoN[nPl - 1, n - 3].Cand := Po2[0].Cand; PoN[nPl - 1, n - 3].Li := Po2[0].Li; PoN[nPl - 1, n - 3].Co := Po2[0].Co;
        PoN[nPl - 1, n - 2].occLiensCo := 0; PoN[nPl - 1, n - 2].Cand := Po2[1].Cand; PoN[nPl - 1, n - 2].Li := Po2[1].Li; PoN[nPl - 1, n - 2].Co := Po2[1].Co;
        PoN[nPl - 1, n - 1].occLiensCo := 0; PoN[nPl - 1, n - 1].Cand := Po2[2].Cand; PoN[nPl - 1, n - 1].Li := Po2[2].Li; PoN[nPl - 1, n - 1].Co := Po2[2].Co;
      end;
      if (Occ = 4) then begin
        inc(n, 4); SetLength(PoN[nPl - 1], n);
        PoN[nPl - 1, n - 4].occLiensCo := 0; PoN[nPl - 1, n - 4].Cand := Po2[0].Cand; PoN[nPl - 1, n - 4].Li := Po2[0].Li; PoN[nPl - 1, n - 4].Co := Po2[0].Co;
        PoN[nPl - 1, n - 3].occLiensCo := 0; PoN[nPl - 1, n - 3].Cand := Po2[1].Cand; PoN[nPl - 1, n - 3].Li := Po2[1].Li; PoN[nPl - 1, n - 3].Co := Po2[1].Co;
        PoN[nPl - 1, n - 2].occLiensCo := 0; PoN[nPl - 1, n - 2].Cand := Po2[2].Cand; PoN[nPl - 1, n - 2].Li := Po2[2].Li; PoN[nPl - 1, n - 2].Co := Po2[2].Co;
        PoN[nPl - 1, n - 1].occLiensCo := 0; PoN[nPl - 1, n - 1].Cand := Po2[3].Cand; PoN[nPl - 1, n - 1].Li := Po2[3].Li; PoN[nPl - 1, n - 1].Co := Po2[3].Co;
      end;
    end; // for Li := 1 to 9
    if (length(PoN) < 4) then Continue;
    if VerifAliSur4LiEt4Co(PoN, Po6, QuatreCol) then begin
      if Config = cJellyLig then StrPosit := StrPositions(Po6, TRUE) else StrPosit := StrPositions(Po6, FALSE);

      OKElim := false; inc(nbJellys);
      BaliserElimSurCo(Po6, QuatreCol, Raiso + ' :' + StrPosit);
      if OKElim then begin
        Reperer(Po6, clFondG(nbJellys - 1), []);
      end;
    end;
  end; //for ic := 49
  if Config = cJellyLig then begin
    Config := cJellyCol; Raiso := 'Jellyfish-Colonnes-4x4';
    GRT := PermuterLiCo(Sudo.GRT);
    goto Recomm;
  end;
  if Config = cJellyCol then GRT := PermuterLiCo(Sudo.GRT);
  Result := nbElim <> 0;
end; // TSudoku.RepererElimParJellyfish2

function TSudoku.RepererElimParSquirmbag: boolean;
label Recomm;
type TPosL = record Cand: tSetOC; Li: byte; Co: byte; occLiensCo: byte; end;
  TPositL = array of array of TPosL;
var ic, Li, occ, n, nPL, nbElim, nbSquirmbag: byte; Candi: char; Po2, Po6: TPositions; PoN: TPositL;
  Raiso, CinqCol: shortString;
  OKElim: boolean; StrPosit: string;
  Config: tConfig;

  function VerifAliSur5LiEt5Co(const PoN: TPositL; var Po67: TPositions; var CinqCol: shortString): boolean;
  //  var CinqCol renvoie les 5 Col
  var l1, l2, jpl1, jpl2, i, j, Co, nl: byte; aliSurCol: boolean;
    setLi, setCo: tSetOC;
  begin

    for l1 := 0 to High(PoN) do begin
      for jpl1 := 0 to high(PoN[l1]) do begin
        Co := PoN[l1, jpl1].Co;
        for l2 := 0 to High(PoN) do begin
          for jpl2 := 0 to high(PoN[l2]) do begin
            if (PoN[l2, jpl2].Co = Co) then begin inc(PoN[l1, jpl1].occLiensCo); inc(PoN[l2, jpl2].occLiensCo); end;
          end;
        end;
      end;
    end;
    nl := 0; SetLength(Po67, nl);
    for i := 0 to High(PoN) do begin
      aliSurCol := true;
      for j := 0 to High(PoN[i]) do begin
        if PoN[i, j].occLiensCo = 2 then aliSurCol := false;
      end;
      if aliSurCol then begin
        for j := 0 to High(PoN[i]) do begin
          inc(nl); SetLength(Po67, nl);
          Po67[nl - 1].Cand := PoN[i, j].Cand;
          Po67[nl - 1].Li := PoN[i, j].Li; Po67[nl - 1].Co := PoN[i, j].Co;
        end;
      end;
    end;
    if length(Po67) = 0 then begin Result := false; EXIT; end;
    // Verif 5 Li 5 Co :
    setLi := []; setCo := [];
    for i := 0 to High(Po67) do begin
      setLi := setLi + [intToStr(Po67[i].Li)[1]];
      setCo := setCo + [intToStr(Po67[i].Co)[1]];
    end;
    CinqCol := CandiToStr(setCo);
    Result := (length(CandiToStr(setLi)) = 5) and (length(CinqCol) = 5);
  end;

  procedure BaliserCaseElim(const cElim: char; const L, C: byte; const Raison: shortString);
  begin
    if cElim in GRT[L, C].Candidats then begin
      GRT[L, C].CElim := cElim; inc(nbElim); OKElim := true;
      if Config = cSquirmbagCol then begin trace(Raison); GRT[L, C].Info := Format('en L%dC%d car %s avec Squirmbag n %d', [L, C, Raison, nbSquirmbag]); end;
      if Config = cSquirmbagLig then begin trace(Raison); GRT[L, C].Info := Format('en L%dC%d car %s avec Squirmbag n %d', [C, L, Raison, nbSquirmbag]); end;
    end;
  end;

  function CaseAEviter(const Li, Co: byte; const Po6: TPositions): boolean;
  var i: byte;
  begin
    Result := false;
    for i := 0 to High(Po6) do begin
      if (Po6[i].Li = Li) and (Po6[i].Co = Co) then begin
        Result := True; EXIT;
      end;
    end;
  end;

  procedure BaliserElimSurCo(const Po6: TPositions; CinqCol: shortString; const Raison: string);
  var i, Li, Co: byte;
  begin
    if length(CinqCol) <> 5 then EXIT;
    for i := 1 to 5 do begin
      Co := StrToInt(CinqCol[i]);
      for Li := 1 to 9 do begin
        if CaseAEviter(Li, Co, Po6) then Continue;
        BaliserCaseElim(Candi, Li, Co, Raison);
      end;
    end;
  end;

begin
  nbElim := 0; Raiso := 'Squirmbag-Lignes-4x4';
  Config := cSquirmbagLig; nbSquirmbag := 0;
  Recomm:
  for ic := 49 to 57 do begin
    Candi := Chr(ic);
    nPL := 0; SetLength(PoN, nPL);
    for Li := 1 to 9 do begin

      occ := OccPosCandLi(Candi, Li, Po2);
      if (occ < 2) or (occ > 5) then Continue;
      inc(nPL);
      SetLength(PoN, nPl); n := 0;
      if (Occ = 2) then begin
        inc(n, 2); SetLength(PoN[nPl - 1], n);
        PoN[nPl - 1, n - 2].occLiensCo := 0; PoN[nPl - 1, n - 2].Cand := Po2[0].Cand; PoN[nPl - 1, n - 2].Li := Po2[0].Li; PoN[nPl - 1, n - 2].Co := Po2[0].Co;
        PoN[nPl - 1, n - 1].occLiensCo := 0; PoN[nPl - 1, n - 1].Cand := Po2[1].Cand; PoN[nPl - 1, n - 1].Li := Po2[1].Li; PoN[nPl - 1, n - 1].Co := Po2[1].Co;
      end;
      if (Occ = 3) then begin
        inc(n, 3); SetLength(PoN[nPl - 1], n);
        PoN[nPl - 1, n - 3].occLiensCo := 0; PoN[nPl - 1, n - 3].Cand := Po2[0].Cand; PoN[nPl - 1, n - 3].Li := Po2[0].Li; PoN[nPl - 1, n - 3].Co := Po2[0].Co;
        PoN[nPl - 1, n - 2].occLiensCo := 0; PoN[nPl - 1, n - 2].Cand := Po2[1].Cand; PoN[nPl - 1, n - 2].Li := Po2[1].Li; PoN[nPl - 1, n - 2].Co := Po2[1].Co;
        PoN[nPl - 1, n - 1].occLiensCo := 0; PoN[nPl - 1, n - 1].Cand := Po2[2].Cand; PoN[nPl - 1, n - 1].Li := Po2[2].Li; PoN[nPl - 1, n - 1].Co := Po2[2].Co;
      end;
      if (Occ = 4) then begin
        inc(n, 4); SetLength(PoN[nPl - 1], n);
        PoN[nPl - 1, n - 4].occLiensCo := 0; PoN[nPl - 1, n - 4].Cand := Po2[0].Cand; PoN[nPl - 1, n - 4].Li := Po2[0].Li; PoN[nPl - 1, n - 4].Co := Po2[0].Co;
        PoN[nPl - 1, n - 3].occLiensCo := 0; PoN[nPl - 1, n - 3].Cand := Po2[1].Cand; PoN[nPl - 1, n - 3].Li := Po2[1].Li; PoN[nPl - 1, n - 3].Co := Po2[1].Co;
        PoN[nPl - 1, n - 2].occLiensCo := 0; PoN[nPl - 1, n - 2].Cand := Po2[2].Cand; PoN[nPl - 1, n - 2].Li := Po2[2].Li; PoN[nPl - 1, n - 2].Co := Po2[2].Co;
        PoN[nPl - 1, n - 1].occLiensCo := 0; PoN[nPl - 1, n - 1].Cand := Po2[3].Cand; PoN[nPl - 1, n - 1].Li := Po2[3].Li; PoN[nPl - 1, n - 1].Co := Po2[3].Co;
      end;
      if (Occ = 5) then begin
        inc(n, 5); SetLength(PoN[nPl - 1], n);
        PoN[nPl - 1, n - 5].occLiensCo := 0; PoN[nPl - 1, n - 5].Cand := Po2[0].Cand; PoN[nPl - 1, n - 5].Li := Po2[0].Li; PoN[nPl - 1, n - 5].Co := Po2[0].Co;
        PoN[nPl - 1, n - 4].occLiensCo := 0; PoN[nPl - 1, n - 4].Cand := Po2[1].Cand; PoN[nPl - 1, n - 4].Li := Po2[1].Li; PoN[nPl - 1, n - 4].Co := Po2[1].Co;
        PoN[nPl - 1, n - 3].occLiensCo := 0; PoN[nPl - 1, n - 3].Cand := Po2[2].Cand; PoN[nPl - 1, n - 3].Li := Po2[2].Li; PoN[nPl - 1, n - 3].Co := Po2[2].Co;
        PoN[nPl - 1, n - 2].occLiensCo := 0; PoN[nPl - 1, n - 2].Cand := Po2[3].Cand; PoN[nPl - 1, n - 2].Li := Po2[3].Li; PoN[nPl - 1, n - 2].Co := Po2[3].Co;
        PoN[nPl - 1, n - 1].occLiensCo := 0; PoN[nPl - 1, n - 1].Cand := Po2[4].Cand; PoN[nPl - 1, n - 1].Li := Po2[4].Li; PoN[nPl - 1, n - 1].Co := Po2[4].Co;
      end;
    end; // for Li := 1 to 9
    if (length(PoN) < 4) then Continue;
    if VerifAliSur5LiEt5Co(PoN, Po6, CinqCol) then begin
      if Config = cSquirmbagLig then StrPosit := StrPositions(Po6, TRUE) else StrPosit := StrPositions(Po6, FALSE);

      OKElim := false; inc(nbSquirmbag);
      BaliserElimSurCo(Po6, CinqCol, Raiso + ' :' + StrPosit);
      if OKElim then begin
        Reperer(Po6, clFondG(nbSquirmbag - 1), []);
      end;
    end;
  end; //for ic := 49
  if Config = cSquirmbagLig then begin
    Config := cSquirmbagCol; Raiso := 'Squirmbag-Colonnes-4x4';
    GRT := PermuterLiCo(Sudo.GRT);
    goto Recomm;
  end;
  if Config = cSquirmbagCol then GRT := PermuterLiCo(Sudo.GRT);
  Result := nbElim <> 0;
end; // TSudoku.RepererElimParSquirmbag

procedure CombinerPparP(NChar: string; const P: byte);
// Place dans SLCombin les Combinaisons des NChar prises P par P

  procedure SuiteR(scum, sr: string; const P: byte);
  var j: Integer;
  begin
    if Length(sr) > 0 then
    begin
      scum := scum + sr[1];
      if Length(scum) < P then
      begin
        for j := 2 to length(sr) do SuiteR(scum, Copy(sr, j, MaxInt), P);
      end else SLCombin.Add(scum);
    end;
  end;

var
  LS, j: integer;
begin
  LS := length(NChar);
  if LS < P then EXIT;
  if LS = P then begin SLCombin.Add(NChar); EXIT; end;

  for j := 1 to length(NChar) do
  begin
    SuiteR('', NChar, P);
    NChar := Copy(NChar, 2, MaxInt);
  end;
end; // CombinerPparP

function TSudoku.OccPosNupletsCaches(const DansLCouB: char; const Candis: tSetOC; const LCouB: byte; var Posit: TPositions): byte;
var Li, Co, LiB, CoB: byte; sCand: shortString;

  function DansCase(const sCandis: shortString; const Li, Co: byte): boolean;
  var i: byte;
  begin
    Result := false;
    if GRT[Li, Co].CaseResolue then EXIT;
    for i := 1 to length(sCandis) do begin
      if sCandis[i] in GRT[Li, Co].Candidats then begin Result := true; EXIT; end;
    end;
  end;

begin
  Result := 0; SetLength(Posit, 0); sCand := CandiToStr(Candis);
  case DansLCouB of
    'L': begin
        for Co := 1 to 9 do begin
          if DansCase(sCand, LCouB, Co) then begin
            inc(Result); SetLength(Posit, Result); Posit[Result - 1].Li := LCouB; Posit[Result - 1].Co := Co;
          end;
        end;
        Result := length(Posit);
      end;
    'C': begin
        for Li := 1 to 9 do begin
          if DansCase(sCand, Li, LCouB) then begin
            inc(Result); SetLength(Posit, Result); Posit[Result - 1].Li := Li; Posit[Result - 1].Co := LCouB;
          end;
        end;
        Result := length(Posit);
      end;
    'B': begin
        for LiB := 1 to 3 do begin
          for CoB := 1 to 3 do begin
            LiCoDeLiBlocCoBloc(LCouB, LiB, CoB, Li, Co);
            if DansCase(sCand, Li, Co) then begin
              inc(Result); SetLength(Posit, Result); Posit[Result - 1].Li := Li; Posit[Result - 1].Co := Co;
            end;
          end;
        end;
        Result := length(Posit);
      end;
  end; //case
end; // TSudoku.OccPosNupletsCaches

function TSudoku.RepererElimSiNupletsCaches(const NU: byte): boolean;
var Li, Co, Bloc, i: byte; sCandU: string; setNuplet: tSetOC; OccP: byte;
  Po: TPositions; stID: shortString;

  function strID: shortString;
  begin
    case NU of
      2: Result := 'Paire cache';
      3: Result := 'Triplet cach';
      4: Result := 'Quadruplet cach';
      5: Result := 'Quintuplet cach';
      6: Result := 'Sextuplet cach';
      7: Result := 'Septuplet cach';
      8: Result := 'Octuplet cach';
    end;
  end;

  procedure BaliserElimSiNupletCache(const socNuplet: tSetOC; const DansLCouB: char; const LCouB: byte; const Dans: TPositions);
  var i: byte; cEl, sd, sn: shortString; socElim: tSetOC;
  begin
    case DansLCouB of
      'L': sd := 'sur ligne';
      'C': sd := 'sur colonne';
      'B': sd := 'dans bloc';
    end;
    for i := 0 to high(Dans) do begin
      socElim := GRT[Dans[i].Li, Dans[i].Co].Candidats - socNuplet;
      cEl := CandiToStr(socElim);
      if length(cEl) > 0 then begin
        GRT[Dans[i].Li, Dans[i].Co].CElim := cEL; sn := CandiToStr(socNuplet);
        if length(cEl) = 1
          then GRT[Dans[i].Li, Dans[i].Co].Info := Format('en L%dC%d car %s %s %s', [Dans[i].Li, Dans[i].Co, stID, sn, sd])
        else GRT[Dans[i].Li, Dans[i].Co].Info := Format('en L%dC%d car %s %s %s', [Dans[i].Li, Dans[i].Co, stID, sn, sd]);
        Result := true;
      end;
    end;
  end; // BaliserElimSiNupletCache

begin
  Result := false; SLCombin := tStringList.Create; stID := strID;
  // Nuplets cachs sur ligne :
  for Li := 1 to 9 do begin
    sCandU := CandiToStr(GetCandLi(Li));
    CombinerPparP(sCandU, NU);
    if SLCombin.count > 0 then begin
      for i := 0 to SLCombin.Count - 1 do begin
        setNuplet := StrToCandi(SLCombin[i]);
        OccP := OccPosNupletsCaches('L', setNuplet, Li, Po);
        if OccP = NU then BaliserElimSiNupletCache(setNuplet, 'L', Li, Po);
      end;
    end;
    SLCombin.Clear;
  end;
  // Nuplets cachs sur colonne :
  for Co := 1 to 9 do begin
    sCandU := CandiToStr(GetCandCo(Co));
    CombinerPparP(sCandU, NU);
    if SLCombin.count > 0 then begin
      for i := 0 to SLCombin.Count - 1 do begin
        setNuplet := StrToCandi(SLCombin[i]);
        OccP := OccPosNupletsCaches('C', setNuplet, Co, Po);
        if OccP = NU then BaliserElimSiNupletCache(setNuplet, 'C', Co, Po);
      end;
    end;
    SLCombin.Clear;
  end;
  // Nuplets cachs dans bloc :
  for Bloc := 1 to 9 do begin
    sCandU := CandiToStr(GetCandBloc(Bloc));
    CombinerPparP(sCandU, NU);
    if SLCombin.count > 0 then begin
      for i := 0 to SLCombin.Count - 1 do begin
        setNuplet := StrToCandi(SLCombin[i]);
        OccP := OccPosNupletsCaches('B', setNuplet, Bloc, Po);
        if OccP = NU then BaliserElimSiNupletCache(setNuplet, 'B', Bloc, Po);
      end;
    end;
    SLCombin.Clear;
  end;
  SLCombin.Free;
end; // TSudoku.RepererElimSiNupletsCaches

function TSudoku.OccPosNupletsNus(const DansLCouB: char; const Candis: tSetOC; const LCouB: byte; var Posit: TPositions): byte;
var Li, Co, LiB, CoB: byte;
begin
  Result := 0; SetLength(Posit, 0);
  case DansLCouB of
    'L': begin
        for Co := 1 to 9 do begin
          if GRT[LCouB, Co].CaseResolue then Continue;
          if GRT[LCouB, Co].Candidats + Candis = Candis then begin
            inc(Result); SetLength(Posit, Result); Posit[Result - 1].Li := LCouB; Posit[Result - 1].Co := Co;
          end;
        end;
      end;
    'C': begin
        for Li := 1 to 9 do begin
          if GRT[Li, LCouB].CaseResolue then Continue;
          if GRT[Li, LCouB].Candidats + Candis = Candis then begin
            inc(Result); SetLength(Posit, Result); Posit[Result - 1].Li := Li; Posit[Result - 1].Co := LCouB;
          end;
        end;
      end;
    'B': begin
        for LiB := 1 to 3 do begin
          for CoB := 1 to 3 do begin
            LiCoDeLiBlocCoBloc(LCouB, LiB, CoB, Li, Co);
            if GRT[Li, Co].CaseResolue then Continue;
            if GRT[Li, Co].Candidats + Candis = Candis then begin
              inc(Result); SetLength(Posit, Result); Posit[Result - 1].Li := Li; Posit[Result - 1].Co := Co;
            end;
          end;
        end;
      end;
  end;
end; // TSudoku.OccPosNupletsNus

function TSudoku.RepererElimSiNupletsNus(const NU: byte): boolean;
var Li, Co, Bloc, i: byte; sCandU: string; setNuplet: tSetOC; OccP: byte;
  Po: TPositions; stID: shortString;

  function strID: shortString;
  begin
    case NU of
      2: Result := 'Paire nue';
      3: Result := 'Triplet nu';
      4: Result := 'Quadruplet nu';
      5: Result := 'Quintuplet nu';
      6: Result := 'Sextuplet nu';
      7: Result := 'Septuplet nu';
      8: Result := 'Octuplet nu';
    end;
  end;

  function BonneCase(const Li, Co: byte; const SaufDans: TPositions; const CandEl: shortString; var CElim: shortString): boolean;
  var jp: byte;
  begin
    CElim := ''; Result := false;
    for jp := 0 to high(SaufDans) do begin
      if (Li = SaufDans[jp].Li) and (Co = SaufDans[jp].Co) then EXIT;
    end;
    Result := true;
    case NU of
      2: begin // 'Paire';
          if CandEl[1] in GRT[Li, Co].Candidats then CElim := CandEl[1];
          if CandEl[2] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[2];
        end;
      3: begin // 'Triplet'
          if CandEl[1] in GRT[Li, Co].Candidats then CElim := CandEl[1];
          if CandEl[2] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[2];
          if CandEl[3] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[3];
        end;
      4: begin //'Quadruplet
          if CandEl[1] in GRT[Li, Co].Candidats then CElim := CandEl[1];
          if CandEl[2] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[2];
          if CandEl[3] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[3];
          if CandEl[4] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[4];
        end;
      5: begin // 'Quintuplet
          if CandEl[1] in GRT[Li, Co].Candidats then CElim := CandEl[1];
          if CandEl[2] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[2];
          if CandEl[3] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[3];
          if CandEl[4] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[4];
          if CandEl[5] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[5];
        end;
      6: begin // 'Sextuplet
          if CandEl[1] in GRT[Li, Co].Candidats then CElim := CandEl[1];
          if CandEl[2] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[2];
          if CandEl[3] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[3];
          if CandEl[4] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[4];
          if CandEl[5] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[5];
          if CandEl[6] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[6];
        end;
      7: begin // 'Septuplet
          if CandEl[1] in GRT[Li, Co].Candidats then CElim := CandEl[1];
          if CandEl[2] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[2];
          if CandEl[3] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[3];
          if CandEl[4] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[4];
          if CandEl[5] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[5];
          if CandEl[6] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[6];
          if CandEl[7] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[7];
        end;
      8: begin // 'Octuplet
          if CandEl[1] in GRT[Li, Co].Candidats then CElim := CandEl[1];
          if CandEl[2] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[2];
          if CandEl[3] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[3];
          if CandEl[4] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[4];
          if CandEl[5] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[5];
          if CandEl[6] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[6];
          if CandEl[7] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[7];
          if CandEl[8] in GRT[Li, Co].Candidats then CElim := CElim + CandEl[8];
        end;
    end;
  end;

  procedure BaliserElimSiNupletsNus(const CandEl: shortString; const DansLCouB: char; const LCouB: byte; const SaufDans: TPositions);
  var LL, CC, LiB, CoB: byte; cEl: shortString;
  begin
    case DansLCouB of
      'L': begin
          for CC := 1 to 9 do begin
            if not BonneCase(LCouB, CC, SaufDans, CandEl, cEl) then Continue;
            if cEl <> '' then begin
              GRT[LCouB, CC].CElim := cEl;
              GRT[LCouB, CC].Info := Format('en L%dC%d car %s %s sur ligne', [LCouB, CC, stID, CandEl]);
              Result := true;
            end;
          end;
        end;
      'C': begin
          for LL := 1 to 9 do begin
            if not BonneCase(LL, LCouB, SaufDans, CandEl, cEl) then Continue;
            if cEl <> '' then begin
              GRT[LL, LCouB].CElim := cEl;
              GRT[LL, LCouB].Info := Format('en L%dC%d car %s %s sur colonne', [LL, LCouB, stID, CandEl]);
              Result := true;
            end;
          end;
        end;
      'B': begin
          for LiB := 1 to 3 do begin
            for CoB := 1 to 3 do begin
              LiCoDeLiBlocCoBloc(LCouB, LiB, CoB, LL, CC);
              if not BonneCase(LL, CC, SaufDans, CandEl, cEl) then Continue;
              if cEl <> '' then begin
                GRT[LL, CC].CElim := cEl;
                GRT[LL, CC].Info := Format('en L%dC%d car %s %s dans bloc', [LL, CC, stID, CandEl]);
                Result := true;
              end;
            end;
          end;
        end;
    end;
  end; // BaliserElimSiNupletsNus

begin
  Result := false; SLCombin := tStringList.Create; stID := strID;
  // Nuplets nus sur ligne :
  for Li := 1 to 9 do begin
    sCandU := CandiToStr(GetCandLi(Li));
    CombinerPparP(sCandU, NU);
    if SLCombin.count > 0 then begin
      for i := 0 to SLCombin.Count - 1 do begin
        setNuplet := StrToCandi(SLCombin[i]);
        OccP := OccPosNupletsNus('L', setNuplet, Li, Po);
        if OccP = NU then BaliserElimSiNupletsNus(SLCombin[i], 'L', Li, Po);
      end;
    end;
    SLCombin.Clear;
  end;
  // Nupletsnus sur colonne :
  for Co := 1 to 9 do begin
    sCandU := CandiToStr(GetCandCo(Co));
    CombinerPparP(sCandU, NU);
    if SLCombin.count > 0 then begin
      for i := 0 to SLCombin.Count - 1 do begin
        setNuplet := StrToCandi(SLCombin[i]);
        OccP := OccPosNupletsNus('C', setNuplet, Co, Po);
        if OccP = NU then BaliserElimSiNupletsNus(SLCombin[i], 'C', Co, Po);
      end;
    end;
    SLCombin.Clear;
  end;
  // Nuplets nus dans bloc :
  for Bloc := 1 to 9 do begin
    sCandU := CandiToStr(GetCandBloc(Bloc));
    CombinerPparP(sCandU, NU);
    if SLCombin.count > 0 then begin
      for i := 0 to SLCombin.Count - 1 do begin
        setNuplet := StrToCandi(SLCombin[i]);
        OccP := OccPosNupletsNus('B', setNuplet, Bloc, Po);
        if (SLCombin[i] = '348') and (bloc = 6) then trace('SL[i]=348 : Bloc = ' + intToStr(Bloc) + ' OccP = ' + intTostr(OccP));
        if OccP = NU then BaliserElimSiNupletsNus(SLCombin[i], 'B', Bloc, Po);
      end;
    end;
    SLCombin.Clear;
  end;
  SLCombin.Free;
end; // TSudoku.RepererElimSiNupletsNus

function TSudoku.RepererElimSiRectangleInterdit: boolean;
var Paires: tPositions; i, nbElim: byte; strPosit: shortString; OKElim: boolean;

  procedure RepererCase(const L, C: byte; cl: Tcolor);
  begin
    //sms(format('L %d,C %d',[L,C])); // si Multi
    if (L<1) or (L>9) or (C<1) or (C>9) then EXIT;
    GRT[L, C].clFond := cl;
  end;

  procedure RepererPaires(const P: TPositions; cl: Tcolor);
  var i: byte;
  begin
    for i := Low(P) to High(P) do RepererCase(P[i].Li, P[i].Co, cl);
  end;

  procedure RepererRect(const PN: tPositions; const P3, P4: tPos; cl: tColor);
  begin
    RepererPaires(PN, cl);
    RepererCase(P3.Li, P3.Co, cl);
    RepererCase(P4.Li, P4.Co, cl);
  end;

  function PairesDansGrille: byte;
  var L, C: byte; sc: shortString;
  begin
    Result := 0;
    SetLength(Paires, Result);
    for L := 1 to 9 do begin
      for C := 1 to 9 do begin
        sc := CandiToStr(GRT[L, C].Candidats);
        if length(sc) = 2 then begin
          inc(Result); SetLength(Paires, Result);
          Paires[Result - 1].Cand := GRT[L, C].Candidats;
          Paires[Result - 1].Li := L;
          Paires[Result - 1].Co := C;
        end;
      end;
    end;
  end;

  function PairesDansGrille2(const Paire: shortString): byte;
  var L, C: byte; sc: shortString;
  begin
    Result := 0;
    SetLength(Paires, Result);
    for L := 1 to 9 do begin
      for C := 1 to 9 do begin
        sc := CandiToStr(GRT[L, C].Candidats);
        if sc = Paire then begin
          inc(Result); SetLength(Paires, Result);
          Paires[Result - 1].Cand := GRT[L, C].Candidats;
          Paires[Result - 1].Li := L;
          Paires[Result - 1].Co := C;
        end;
      end;
    end;
  end;

  function Dans2Blocs(const P1, P2, P3, P4: tPos): boolean;
  var B1, B2, B3, B4: char; sc: tSetOC;
  begin
    B1 := IntToStr(NumBloc(P1.Li, P1.Co))[1]; B2 := IntToStr(NumBloc(P2.Li, P2.Co))[1];
    B3 := IntToStr(NumBloc(P3.Li, P3.Co))[1]; B4 := IntToStr(NumBloc(P4.Li, P4.Co))[1];
    sc := [B1] + [B2] + [B3] + [B4];
    Result := length(CandiToStr(sc)) = 2;
  end;

  procedure BaliserCaseElim(const cElim: char; const L, C: byte; const Raison: shortString);
  begin
    //sms(format('L %d,C %d',[L,C])); // si 1
    if (L<1) or (L>9) or (C<1) or (C>9) then EXIT;
    if cElim in GRT[L, C].Candidats then begin
      GRT[L, C].CElim := GRT[L, C].CElim + cElim; inc(nbElim); OKElim := true;
      GRT[L, C].Info := Format('en L%dC%d car %s', [L, C, Raison + strPosit]);
    end;
  end;

  procedure EliminerRIType1(const Po: tPos; const PaireBase: shortString);
  begin
    BaliserCaseElim(PaireBase[1], Po.Li, Po.Co, 'Rectangle interdit type 1 avec :');
    BaliserCaseElim(PaireBase[2], Po.Li, Po.Co, 'Rectangle interdit type 1 avec :');
  end;

  procedure ExtraCandis(const P3, P4: tPos; const PaireBase: shortString; var EC3, EC4: tSetOC);
  begin
    ec3 := P3.Cand - [PaireBase[1]] - [PaireBase[2]];
    ec4 := P4.Cand - [PaireBase[1]] - [PaireBase[2]];
  end;

  procedure EliminerRIType2(const P3, P4: tPos; const MemeExtraCandi: tSetOC);
  var MemeExtra: char; L, C, B3, B4, LB, CB, Li, Co: byte;
  begin
    MemeExtra := CandiToStr(MemeExtraCandi)[1];
    if MemeLig(P3, P4) then begin
      L := P3.Li;
      for C := 1 to 9 do begin
        if (C = P3.Co) or (C = P4.Co) then Continue;
        if MemeExtra in GRT[L, C].Candidats then BaliserCaseElim(MemeExtra, L, C, 'Rectangle interdit type 2 avec :');
      end;
    end else
      if MemeCol(P3, P4) then begin
      C := P3.Co;
      for L := 1 to 9 do begin
        if (L = P3.Li) or (L = P4.Li) then Continue;
        if MemeExtra in GRT[L, C].Candidats then BaliserCaseElim(MemeExtra, L, C, 'Rectangle interdit type 2 avec :');
      end;
    end;
    B3 := NumBloc(P3.Li, P3.Co); B4 := NumBloc(P4.Li, P4.Co);
    if B3 = B4 then begin
      for LB := 1 to 3 do begin
        for CB := 1 to 3 do begin
          LiCoDeLiBlocCoBloc(B3, LB, CB, Li, Co);
          if ((Li = P3.Li) and (Co = P3.Co)) or ((Li = P4.Li) and (Co = P4.Co)) then Continue;
          if MemeExtra in GRT[Li, Co].Candidats then BaliserCaseElim(MemeExtra, Li, Co, 'Rectangle interdit type 2 avec :');
        end;
      end;
    end;
  end;

  procedure EliminerRIType3(const P3, P4: tPos; const EC3, EC4: tSetOC; const LP, CP, BP: byte);
  var sExtras: tSetOC; L, C, LB, CB, Li, Co, ic: byte; sElim: ShortString;
  begin
    sExtras := EC3 + EC4; sElim := CandiToStr(sExtras);
    for ic := 1 to length(sElim) do begin
      if CP <> 0 then begin
        for L := 1 to 9 do begin
          if GRT[L, CP].Candidats = sExtras then Continue;
          if (L = P3.Li) or (L = P4.Li) then Continue;
          BaliserCaseElim(sElim[ic], L, CP, 'Rectangle interdit type 3 avec :');
        end;
      end else
        if LP <> 0 then begin
        for C := 1 to 9 do begin
          if GRT[LP, C].Candidats = sExtras then Continue;
          if (C = P3.Co) or (C = P4.Co) then Continue;
          BaliserCaseElim(sElim[ic], LP, C, 'Rectangle interdit type 3 avec :');
        end;
      end else
        if BP <> 0 then begin
        for LB := 1 to 3 do begin
          for CB := 1 to 3 do begin
            LiCoDeLiBlocCoBloc(BP, LB, CB, Li, Co);
            if GRT[Li, Co].Candidats = sExtras then Continue;
            if ((Li = P3.Li) and (Co = P3.Co)) or ((Li = P4.Li) and (Co = P4.Co)) then Continue;
            BaliserCaseElim(sElim[ic], Li, Co, 'Rectangle interdit type 3 avec :');
          end;
        end;
      end;
    end;
  end;

  procedure EliminerRIType4(const P3, P4: tPos; CELim: Char);
  begin
    BaliserCaseElim(CELim, P3.Li, P3.Co, 'Rectangle interdit type 4 avec :');
    BaliserCaseElim(CELim, P4.Li, P4.Co, 'Rectangle interdit type 4 avec :');
  end;

  procedure EliminerRITypeSolutionMultiple(const Paires: tPositions; const Paire: shortString);
  begin
    BaliserCaseElim(Paire[1], Paires[0].Li, Paires[0].Co, 'Rectangle  deux solutions avec :');
    BaliserCaseElim(Paire[2], Paires[1].Li, Paires[1].Co, 'Rectangle  deux solutions avec :');
    BaliserCaseElim(Paire[1], Paires[2].Li, Paires[2].Co, 'Rectangle  deux solutions avec :');
    BaliserCaseElim(Paire[2], Paires[3].Li, Paires[3].Co, 'Rectangle  deux solutions avec :');
  end;

  function PairesCachees2(const Sur: char; const PaireBase: shortString; const P1, P2: tPos; var P3, P4: tPos): boolean;
  var L, C: byte; c1, c2: char;
  begin
    Result := false; c1 := PaireBase[1]; c2 := PaireBase[2];
    case Sur of
      'L': begin
          for L := 1 to 9 do begin
            if L = P1.Li then Continue;
            if (c1 in GRT[L, P1.Co].Candidats) and (c2 in GRT[L, P1.Co].Candidats)
              and (c1 in GRT[L, P2.Co].Candidats) and (c2 in GRT[L, P2.Co].Candidats) then begin
              P3.Cand := GRT[L, P1.Co].Candidats; P3.Li := L; P3.Co := P1.Co;
              P4.Cand := GRT[L, P2.Co].Candidats; P4.Li := L; P4.Co := P2.Co;
              Result := EnRectangle(P1, P2, P3, P4) and (length(CandiToStr(P3.Cand)) = 3) and (length(CandiToStr(P4.Cand)) = 3);
              if Result then EXIT;
            end;
          end;
        end;
      'C': begin
          for C := 1 to 9 do begin
            if C = P1.Co then Continue;
            if (c1 in GRT[P1.Li, C].Candidats) and (c2 in GRT[P1.Li, C].Candidats)
              and (c1 in GRT[P2.Li, C].Candidats) and (c2 in GRT[P2.Li, C].Candidats) then begin
              P3.Cand := GRT[P1.Li, C].Candidats; P3.Co := C; P3.Li := P1.Li;
              P4.Cand := GRT[P2.Li, C].Candidats; P4.Co := C; P4.Li := P2.Li;
              Result := EnRectangle(P1, P2, P3, P4) and (length(CandiToStr(P3.Cand)) = 3) and (length(CandiToStr(P4.Cand)) = 3);
              if Result then EXIT;
            end;
          end;
        end;
    end;
  end;

  function IDRIType23(const P3, P4: tPos; const EC3, EC4: tSetOC; var LP, CP, BP: byte): byte;
  // Result = 2 ou 3 si RI de type 2 ou 3 et 0 si indtermin
  // var LP,CP, et BP renvoient l'unit partage par les extras et le NUpletNu, sinon 0
  var sExtras: tSetOC; L, C, B, LB, CB: byte;
  begin
    Result := 0; LP := 0; CP := 0; BP := 0;
    // A pour Type 2 :
    if EC3 = EC4 then begin Result := 2; EXIT; end;
    sExtras := EC3 + EC4;
    // B pour Type 3 :
    // Sur Colonne :
    if MemeCol(P3, P4) then begin
      C := P3.Co; CP := C;
      for L := 1 to 9 do begin
        if GRT[L, C].Candidats = sExtras then begin
          Result := 3; EXIT;
        end;
      end;
    end else // Sur Ligne :
      if MemeLig(P3, P4) then begin
      L := P3.Li; LP := L;
      for C := 1 to 9 do begin
        if GRT[L, C].Candidats = sExtras then begin
          Result := 3; EXIT;
        end;
      end;
    end else // Dans Bloc de P3 ou P4 :
      if MemeBloc(P3, P4) then begin
      B := NumBloc(P3.Li, P3.Co); BP := B;
      for LB := 1 to 3 do begin
        for CB := 1 to 3 do begin
          LiCoDeLiBlocCoBloc(B, LB, CB, L, C);
          if GRT[L, C].Candidats = sExtras then begin
            Result := 3; EXIT;
          end;
        end;
      end;
      B := NumBloc(P4.Li, P4.Co); BP := B;
      for LB := 1 to 3 do begin
        for CB := 1 to 3 do begin
          LiCoDeLiBlocCoBloc(B, LB, CB, L, C);
          if GRT[L, C].Candidats = sExtras then begin
            Result := 3; EXIT;
          end;
        end;
      end;
    end
  end;

  function IDRIType4(const P3, P4: tPos; const PaireBase: shortString; var CELim: char): byte;
  // Result = 4 si RI de type 4 et 0 si indtermin
  var B3, ic: byte;
  begin
    Result := 0; CELim := #0;
    for ic := 1 to 2 do begin
       // Sur Ligne :
      if MemeLig(P3, P4) then begin
        if NbCasesAvecCandiEnLig(PaireBase[ic], P3.Li) = 2 then begin
          if ic = 1 then CELim := PaireBase[2] else CELim := PaireBase[1];
          Result := 4;
        end;
      end else
        if MemeCol(P3, P4) then begin
        if NbCasesAvecCandiEnCol(PaireBase[ic], P3.Co) = 2 then begin
          if ic = 1 then CELim := PaireBase[2] else CELim := PaireBase[1];
          Result := 4;
        end;
      end else
        if MemeBloc(P3, P4) then begin
        B3 := NumBloc(P3.Li, P3.Co);
        if NbCasesAvecCandiEnBloc(PaireBase[ic], B3) = 2 then begin
          if ic = 1 then CELim := PaireBase[2] else CELim := PaireBase[1];
          Result := 4;
        end;
      end;
    end;
  end;

  function IDConfig(const Paire: shortString): shortString;
  var P3, P4: tPos; lg, RIType, LP, CP, BP: byte; EC3, EC4: tSetOC; CELim: char;
  begin
    Result := '?';
    lg := length(Paires);
    case lg of
      2: begin // RI de type 2, 3 ou 4
          if MemeLig(Paires[0], Paires[1]) then begin
            if PairesCachees2('L', Paire, Paires[0], Paires[1], P3, P4) then begin
              if Dans2Blocs(Paires[0], Paires[1], P3, P4) then begin
                strPosit := #13#10 + Format('- Paire %s dans L%dC%d + L%dC%d + L%dC%d + L%dC%d', [Paire, Paires[0].Li, Paires[0].Co, Paires[1].Li, Paires[1].Co, P3.Li, P3.Co, P4.Li, P4.Co]);
                OKElim := false;
                ExtraCandis(P3, P4, Paire, EC3, EC4);
                RIType := IDRIType23(P3, P4, EC3, EC4, LP, CP, BP);
                if RIType = 2 then begin // RI de type 2
                  EliminerRIType2(P3, P4, EC3);
                  if OKElim then RepererRect(Paires, P3, P4, clYellow);
                end else // RI de type 3
                  if RIType = 3 then begin
                  EliminerRIType3(P3, P4, EC3, EC4, LP, CP, BP);
                  if OKElim then RepererRect(Paires, P3, P4, clYellow);
                end else
                  if IDRIType4(P3, P4, Paire, CELim) = 4 then begin
                  EliminerRIType4(P3, P4, CELim);
                  if OKElim then RepererRect(Paires, P3, P4, clYellow);
                end;
              end;
            end;
          end else
            if MemeCol(Paires[0], Paires[1]) then begin
            if PairesCachees2('C', Paire, Paires[0], Paires[1], P3, P4) then begin
              if Dans2Blocs(Paires[0], Paires[1], P3, P4) then begin
                strPosit := #13#10 + Format('- Paire %s dans L%dC%d + L%dC%d + L%dC%d + L%dC%d', [Paire, Paires[0].Li, Paires[0].Co, Paires[1].Li, Paires[1].Co, P3.Li, P3.Co, P4.Li, P4.Co]);
                OKElim := false;
                ExtraCandis(P3, P4, Paire, EC3, EC4);
                RIType := IDRIType23(P3, P4, EC3, EC4, LP, CP, BP);
                if RIType = 2 then begin // RI de type 2
                  EliminerRIType2(P3, P4, EC3);
                  if OKElim then RepererRect(Paires, P3, P4, clYellow);
                end else // RI de type 3
                  if RIType = 3 then begin
                  EliminerRIType3(P3, P4, EC3, EC4, LP, CP, BP);
                  if OKElim then RepererRect(Paires, P3, P4, clYellow);
                end else
                  if IDRIType4(P3, P4, Paire, CELim) = 4 then begin
                  EliminerRIType4(P3, P4, CELim);
                  if OKElim then RepererRect(Paires, P3, P4, clYellow);
                end;
              end;
            end;
          end;
        end;
      3: begin // RI de type 1
          if EnEquerre4ieme(Paires[0], Paires[1], Paires[2], P4) then begin
            if Dans2Blocs(Paires[0], Paires[1], Paires[2], P4) then begin
              strPosit := #13#10 + Format('- Paire %s dans L%dC%d + L%dC%d + L%dC%d + L%dC%d', [Paire, Paires[0].Li, Paires[0].Co, Paires[1].Li, Paires[1].Co, Paires[2].Li, Paires[2].Co, P4.Li, P4.Co]);
              EliminerRIType1(P4, Paire);
              if OKElim then RepererRect(Paires, P4, P4, clYellow);
            end
          end;
        end;
      4: begin // RI de type solution multiple
          if EnRectangle(Paires[0], Paires[1], Paires[2], Paires[3]) then begin
            if Dans2Blocs(Paires[0], Paires[1], Paires[2], Paires[3]) then begin
              strPosit := #13#10 + Format('- Paire %s dans L%dC%d + L%dC%d + L%dC%d + L%dC%d', [Paire, Paires[0].Li, Paires[0].Co, Paires[1].Li, Paires[1].Co, Paires[2].Li, Paires[2].Co, Paires[3].Li, Paires[3].Co]);
              EliminerRITypeSolutionMultiple(Paires, Paire);
            end else sms('RI de type solution multiple dans mme bloc');
          end;
        end;
    end;
  end;

begin
  Result := False; nbElim := 0;
  if PairesDansGrille < 2 then EXIT;
  SLCombin := tStringList.Create;
  CombinerPparP('123456789', 2);
  for i := 0 to SLCombin.Count - 1 do begin
    if PairesDansGrille2(SLCombin[i]) < 2 then Continue;
    IDConfig(SLCombin[i]);
  end;
  SLCombin.Free;
  Result := nbElim <> 0;
end; // TSudoku.RepererElimSiRectangleInterdit

function TSudoku.GrilleClone(const Grille: TGRTrav): TGRTrav;
var Li, Co: byte;
begin
  for Li := 1 to 9 do begin
    for Co := 1 to 9 do begin
      with Result[Li, Co] do begin
        ValReso := Grille[Li, Co].ValReso;
        CaseResolue := Grille[Li, Co].CaseResolue;
        CoulCase := Grille[Li, Co].CoulCase;
        Candidats := Grille[Li, Co].Candidats;
        NumRes := Grille[Li, Co].NumRes;
        Info := Grille[Li, Co].Info;
        CElim := Grille[Li, Co].CElim;
        CResu := Grille[Li, Co].CResu;
        clFond := Grille[Li, Co].clFond;
      end;
    end;
  end;
end;

function TSudoku.NbCasesResolues(const Grille: TGRTrav): byte;
var Li, Co: byte;
begin
  Result := 0;
  for Li := 1 to 9 do begin
    for Co := 1 to 9 do begin
      if Grille[Li, Co].CaseResolue then inc(Result);
    end;
  end;
end;

procedure TSudoku.InitGrilleMem1;
begin
  GrilleMem1 := GrilleClone(GRT);
end;

function TSudoku.ResolEmplaJumeaux: boolean;
//      Rsolution avec "Logique "Emplacements jumeaux"
label Recomm1;
var Li, Co: byte; Cand: char; PJ: TPositions; GRBack: TGRTrav; ju, ra, nPJ: integer;

  function NbPairesJumeauxDansGrille: integer;
  var L, C, B, n, i: byte; Posit: TPositions;
  begin
    n := 0; SetLength(PJ, n);
    for B := 1 to 9 do begin
      if EmplaJumeauxEnBloc(B, Cand, Posit) then begin
        inc(n, length(Posit)); SetLength(PJ, n);
        for i := high(Posit) downto 0 do begin
          PJ[n - i - 1].Cand := Posit[i].Cand; PJ[n - i - 1].Li := Posit[i].Li; PJ[n - i - 1].Co := Posit[i].Co;
        end;
      end;
    end;
    for L := 1 to 9 do begin
      if EmplaJumeauxEnLi(L, Cand, Posit) then begin
        inc(n, length(Posit)); SetLength(PJ, n);
        for i := high(Posit) downto 0 do begin
          PJ[n - i - 1].Cand := Posit[i].Cand; PJ[n - i - 1].Li := Posit[i].Li; PJ[n - i - 1].Co := Posit[i].Co;
        end;
      end;
    end;
    for C := 1 to 9 do begin
      if EmplaJumeauxEnCo(C, Cand, Posit) then begin
        inc(n, length(Posit)); SetLength(PJ, n);
        for i := high(Posit) downto 0 do begin
          PJ[n - i - 1].Cand := Posit[i].Cand; PJ[n - i - 1].Li := Posit[i].Li; PJ[n - i - 1].Co := Posit[i].Co;
        end;
      end;
    end;
    Result := length(PJ) div 2;
  end;

begin
  Result := false; Couleur := clResLogique;
  GRT := GrilleClone(GrilleMem1);
  nPJ := NbPairesJumeauxDansGrille;
  if nPJ < 5 then begin
    sms('Trop peu de candidats en emplacements jumeaux dans cette grille : Suite avec ResolAleatoire');
    ResolAleatoire;
    EXIT;
  end;

  Randomize;
  Recomm1:
  while Result = False do begin
    GRT := GrilleClone(GrilleMem1);
    NCRes := NbCasesResolues(GRT);
    ju := 0;
    repeat
      if ToucheCla(VK_ESCAPE) or ToucheCla(VK_END) then EXIT;
      if NbPairesJumeauxDansGrille = 0 then EXIT;
      ra := Random(2);
      if (ju + ra) > High(PJ) then begin sms('Il reste un ou des jumeaux : Re-clicker'); EXIT; end;
      Li := PJ[ju + ra].Li; Co := PJ[ju + ra].Co; Cand := CandiToStr(PJ[ju + ra].Cand)[1];
      if GRT[Li, Co].CaseResolue then Continue;
      GRBack := GrilleClone(GRT); // On mmorise la grille avant d'injecter le candidat-Rsulat dans la 1ire case pour pouvoir revenir en arrire en cas d'erreur
      if Cand in GRT[Li, Co].Candidats then begin
        CandiToRes(Cand, Li, Co, Couleur, FALSE);
        ResolAvecEmplaOuCandiUnique(FALSE);
        if ErrCaseVideNonResolue or ErrValResDoublon then begin
          GRT := GrilleClone(GRBack); // Rcup de la grille d'avant
          if ra = 1 then ra := 0 else ra := 1; // on permute les indices pour injecter le candidat-rsultat dans la 2ime case de l'emplacement de jumeaux
          Li := PJ[ju + ra].Li; Co := PJ[ju + ra].Co; Cand := CandiToStr(PJ[ju + ra].Cand)[1];
          if GRT[Li, Co].CaseResolue then Continue;
          CandiToRes(Cand, Li, Co, Couleur, FALSE);
          ResolAvecEmplaOuCandiUnique(FALSE);
          if ErrCaseVideNonResolue or ErrValResDoublon then goto Recomm1;
        end else
          if ControleRes = 'Contrle : OK' then begin
          Result := true; GrilleResolue := true; EXIT;
        end;
      end;
      inc(ju, 2);
    until ju >= High(PJ);
  end;

end; // TSudoku.ResolEmplaJumeaux

function TSudoku.ResolAleatoire: boolean;
//      Pour Rsolution de grilles avec trs peu de valeurs rvles : Utilis pour gnrer des Grilles Alatoires
label Recommencer;
var Li, Co, i: byte; sCand: shortString;

begin
  Result := false; Couleur := clResLogique;
  Recommencer:
  while Result = False do begin
    GRT := GrilleClone(GrilleMem1);
    NCRes := NbCasesResolues(GRT);
    if ToucheCla(VK_ESCAPE) or ToucheCla(VK_END) then EXIT;
    for Li := 1 to 9 do begin
      for Co := 1 to 9 do begin
        if GRT[Li, Co].CaseResolue then Continue;
        sCand := CandiToStr(GRT[Li, Co].Candidats);
        i := Random(length(sCand)) + 1;
        CandiToRes(sCand[i], Li, Co, Couleur, FALSE);
        ResolAvecEmplaOuCandiUnique(FALSE);
        if ErrCaseVideNonResolue or ErrValResDoublon then begin
          ModifManuCandis(sCand[i], Li, Co, 'S'); // Suppression
          goto Recommencer;
        end else
          if ControleRes = 'Contrle : OK' then begin
          Result := true; GrilleResolue := true; EXIT;
        end;
      end;
    end;
  end;
end; // TSudoku.ResolAleatoire

function TSudoku.ChaineForceePaires: boolean;
type tGS = array[1..9, 1..9] of shortString;
label Recomm;
var Paires: TPositions; Li, Co, ict: byte; G1, G2: tGS; ct: char;

  procedure RepererCase(const L, C: byte; cl: Tcolor);
  begin
    GRT[L, C].clFond := cl;
  end;

  procedure RepererPaires(const P: TPositions; cl: Tcolor);
  var i: byte;
  begin
    for i := Low(P) to High(P) do RepererCase(P[i].Li, P[i].Co, cl);
  end;

  function PairesDansGrille: byte;
  var L, C: byte; sc: shortString;
  begin
    Result := 0;
    SetLength(Paires, Result);
    for L := 1 to 9 do begin
      for C := 1 to 9 do begin
        sc := CandiToStr(GRT[L, C].Candidats);
        if length(sc) = 2 then begin
          inc(Result); SetLength(Paires, Result);
          Paires[Result - 1].Cand := GRT[L, C].Candidats;
          Paires[Result - 1].Li := L;
          Paires[Result - 1].Co := C;
        end;
      end;
    end;
  end;

  procedure CreeChaine(const CandTest: char; const LiD, CoD: byte; var GT: tGS);
  label Recomm;
  var cd: char; Li, Co: byte; OkModif: boolean;

    procedure Repercute(const Cand: char; const L, C: byte; var GT: tGS);
    var sa: string; po: byte; s2: shortString;
    begin
      s2 := GT[L, C]; sa := s2;
      po := pos(Cand, s2);
      if po > 0 then begin
        delete(s2, po, 1);
        GT[L, C] := s2;
        OkModif := true;
      end
    end;

    procedure Effacer(Cand: char; const Li0, Co0: byte; var GT: tGS);
    var L, C, LB, CB, LL, CC, BoC: byte;
    begin
      L := Li0;
      for C := 1 to 9 do begin
        if (C = Co0) or (GT[L, C] = 'Rsolue') then Continue;
        Repercute(Cand, L, C, GT);
      end;
      C := Co0;
      for L := 1 to 9 do begin
        if (L = Li0) or (GT[L, C] = 'Rsolue') then Continue;
        Repercute(Cand, L, C, GT);
      end;
      BoC := NumBloc(Li0, Co0);
      for LB := 1 to 3 do begin
        for CB := 1 to 3 do begin
          LiCoDeLiBlocCoBloc(BoC, LB, CB, LL, CC);
          if ((LL = Li0) and (CC = Co0)) or (GT[LL, CC] = 'Rsolue') then Continue;
          Repercute(Cand, LL, CC, GT);
        end;
      end;
    end;

  begin
    Recomm:
    Effacer(CandTest, LiD, CoD, GT);
    OkModif := false;
    for Li := 1 to 9 do begin
      for Co := 1 to 9 do begin
        if GT[Li, Co] = 'Rsolue' then Continue;
        if length(GT[Li, Co]) = 1 then begin
          cd := GT[Li, Co][1];
          Effacer(cd, Li, Co, GT);
        end;
      end;
    end;
    if OkModif then goto Recomm;
  end;

  procedure BaliserCase(const Li, Co: byte; const SR: shortString);
  var sCand: shortString; SetSR, SetElim: tSetOC;
  begin
    if length(SR) = 0 then EXIT;
    if length(SR) = 1 then begin
      GRT[Li, Co].Info := Format('Candidat %s = Rsulat pour L%dC%d car Candidat forc en chane de Paires ', [SR[1], Li, Co]);
      GRT[Li, Co].CResu := SR[1]; GRT[Li, Co].CElim := '';
    end else begin
      sCand := CandiToStr(GRT[Li, Co].Candidats);
      if length(SR) < length(sCand) then begin
        SetSR := StrToCandi(SR);
        if SetSR * GRT[Li, Co].Candidats = SetSR then begin
          SetElim := GRT[Li, Co].Candidats - SetSR;
          GRT[Li, Co].Info := Format('en L%dC%d car chane force de Paires', [Li, Co]);
          GRT[Li, Co].CElim := CandiToStr(SetElim);
        end;
      end;
    end;
  end;

  procedure Cloner; // Cration de deux clones
  var L, C: byte;
  begin
    for L := 1 to 9 do begin
      for C := 1 to 9 do begin
        if GRT[L, C].CaseResolue then begin
          G1[L, C] := 'Rsolue'; G2[L, C] := G1[L, C];
        end else begin
          G1[L, C] := CandiToStr(GRT[L, C].Candidats); G2[L, C] := G1[L, C];
        end;
      end;
    end;
  end;

  function SiCaseVide(const ACauseDe: tPos; const GT: tGS): boolean;
  var L, C: byte;
  begin
    Result := False;
    // Cases vides de tout candidat :
    for L := 1 to 9 do begin
      for C := 1 to 9 do begin
        if GT[L, C] = '' then begin
          GRT[ACauseDe.Li, ACauseDe.Co].Info := Format('en L%dC%d car causerait une erreur dans chane force', [ACauseDe.Li, ACauseDe.Co]);
          GRT[ACauseDe.Li, ACauseDe.Co].CElim := ct;
          Result := True; EXIT;
        end;
      end;
    end;
  end;

begin
  if PairesDansGrille < 4 then begin
    Trace('Chaine Forcee de Paires : Pas assez de paires : il en faut au minimum 4');
    Result := false; EXIT;
  end;

  for ict := 0 to high(Paires) do begin

    Cloner;

    ct := CandiToStr(Paires[ict].Cand)[1];
    CreeChaine(ct, Paires[ict].Li, Paires[ict].Co, G1);
    if SiCaseVide(Paires[ict], G1) then Continue;

    ct := CandiToStr(Paires[ict].Cand)[2];
    CreeChaine(ct, Paires[ict].Li, Paires[ict].Co, G2);
    if SiCaseVide(Paires[ict], G2) then Continue;

    for Li := 1 to 9 do begin
      for Co := 1 to 9 do begin
        if GRT[Li, Co].CaseResolue then Continue;
        if G1[Li, Co] = G2[Li, Co] then begin
          BaliserCase(Li, Co, G1[Li, Co]);
        end;
      end;
    end;
  end;
  Result := true;
end; // TSudoku.ChaineForceePaires

function TSudoku.ChaineForceePcasesNcandidats: boolean;
// Logique "Candidat forc en chane de P cases  N candidats chacune" :
label Recomm;
type tGClones = array of TGRTrav;
var GClones: tGClones; GRini: TGRTrav; CaseTest: TCellule; iclo, Li, Co: byte;
  ct: char; sCand: shortString; NCRes1: integer; YaEuElim : boolean;

  procedure Cloner(nc: byte); // Cration de nc clones
  var i: byte;
  begin
    SetLength(GClones, nc);
    for i := 0 to nc - 1 do begin
      GClones[i] := GrilleClone(GRini);
    end;
  end;

  procedure PermuterElimEnRes(var GT: TGRTrav);
  var L, C: byte; sCand: ShortString; SetRes: tSetOC; cr: char;
  begin
    for L := 1 to 9 do begin
      for C := 1 to 9 do begin
        if GT[L, C].CaseResolue then Continue;
        sCand := CandiToStr(GT[L, C].Candidats);
        if length(GT[L, C].CElim)>0 then YaEuElim:=True;
        if length(sCand) - length(GT[L, C].CElim) = 1 then begin
          SetRes := GT[L, C].Candidats - StrToCandi(GT[L, C].CElim);
          cr := CandiToStr(SetRes)[1];
          GT[L, C].CResu := cr; GT[L, C].CElim := ''; GT[L, C].Info := Format('%s = Rsultat en L%dC%d car enchanements', [cr, L, C]);
        end;
      end;
    end;
  end;

begin
  GRini := GrilleClone(GRT); Couleur := clFuchsia; NCRes1 := NCRes; YaEuElim:=False;
  for Li := 1 to 9 do begin
    for Co := 1 to 9 do begin
      if GRini[Li, Co].CaseResolue then Continue;
      CaseTest := GRini[Li, Co];
      sCand := CandiToStr(CaseTest.Candidats);
      Cloner(length(sCand));
      for iclo := 1 to length(sCand) do begin
        ct := sCand[iclo]; GRT := GClones[iclo - 1];
        CandiToRes(ct, Li, Co, Couleur, FALSE);
        ResolAvecEmplaOuCandiUnique(FALSE);
        if ErrCaseVideNonResolue or ErrValResDoublon then begin
          if pos(ct, CaseTest.CElim) = 0 then begin
            CaseTest.CElim := CaseTest.CElim + ct;
            CaseTest.Info := Format('en L%dC%d car chane ', [Li, Co]);
            CaseTest.NumRes := 0; GRini[Li, Co] := CaseTest;
          end;
        end;
      end;
    end;
  end;
  GRT := GrilleClone(GRini);
  PermuterElimEnRes(GRT);
  NCRes := NCRes1;
  Result := YaEuElim;
end; // TSudoku.ChaineForceePcasesNcandidats

function TSudoku.XYZ_Wing(var Li, Co: byte; var CandRes: char): boolean;
type TPo = record Li: byte; Co: byte; end;
var Bloc, L, C, LL, CC: byte; sCand3, sCand2A, sCand2B: string;
  PositA, PositB: TPo; CandiCommun: char;

  function PaireDansMemeBloc(const sCandPaire: string; const Bloc: byte; var Po: TPo): boolean;
  var L, C, LL, CC: byte; Cand: TSetOC;
  begin
    Result := False; Cand := StrToCandi(sCandPaire);
    for L := 1 to 3 do begin
      for C := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(Bloc, L, C, LL, CC);
        if GRT[LL, CC].CaseResolue then Continue;
        if GRT[LL, CC].Candidats = Cand then begin
          Result := True; Po.Li := LL; Po.Co := CC; EXIT;
        end;
      end;
    end;
  end;

  function PaireSurMemeLiOuCoHorsBloc(const sCandPaire: string; const Li, Co, Bloc: byte; var Po: TPo): boolean;
  var L, C: byte; Cand: TSetOC;
  begin
    Result := False; Cand := StrToCandi(sCandPaire);
    for L := 1 to 9 do begin // Recherche sur Colonne :
      if GRT[L, Co].CaseResolue then Continue;
      if (GRT[L, Co].Candidats = Cand) and (numBloc(L, Co) <> Bloc) then begin
        Result := True; Po.Li := L; Po.Co := Co; EXIT;
      end;
    end;
    for C := 1 to 9 do begin // Sinon Recherche sur Ligne :
      if GRT[Li, C].CaseResolue then Continue;
      if (GRT[Li, C].Candidats = Cand) and (numBloc(Li, C) <> Bloc) then begin
        Result := True; Po.Li := Li; Po.Co := C; EXIT;
      end;
    end;
  end;

  procedure CasesCible(const PositHorsBloc: TPo; const LiXYZ, CoXYZ, Bloc: byte);
  var L, C: byte; sCand: string; sRes: string;
  begin
    if PositHorsBloc.Li = LiXYZ then begin
      L := LiXYZ;
      for C := 1 to 9 do begin
        if (NumBloc(L, C) <> Bloc) or (C = CoXYZ) then Continue;
        if CandiCommun in GRT[L, C].Candidats then begin
          sCand := CandiToStr(GRT[L, C].Candidats);
          if length(sCand) <> 2 then begin
            GRT[L, C].CElim := CandiCommun;
            GRT[L, C].Info := Format(' supprimable en L%dC%d car XYZ-Wing(%s)', [L, C, sCand3]);
            Result := true;
          end else begin
            sRes := AnsiReplaceStr(sCand, CandiCommun, '');
            GRT[L, C].Info := Format('Candidat %s = Rsultat pour case L%dC%d car XYZ-Wing(%s)', [sRes, L, C, sCand3]); ;
            GRT[L, C].CResu := sRes[1];
            Result := true;
          end;
        end;
      end;
      EXIT;
    end; // if PositHorsBloc.Li
    if PositHorsBloc.Co = CoXYZ then begin
      C := CoXYZ;
      for L := 1 to 9 do begin
        if (NumBloc(L, C) <> Bloc) or (C = CoXYZ) then Continue;
        if CandiCommun in GRT[L, C].Candidats then begin
          sCand := CandiToStr(GRT[L, C].Candidats);
          if length(sCand) <> 2 then begin
            GRT[L, C].CElim := CandiCommun;
            GRT[L, C].Info := Format(' supprimable en L%dC%d car XYZ-Wing(%s)', [L, C, sCand3]);
            Result := true;
          end else begin
            sRes := AnsiReplaceStr(sCand, CandiCommun, '');
            GRT[L, C].Info := Format('Candidat %s = Rsultat pour case L%dC%d car XYZ-Wing(%s)', [sRes, L, C, sCand3]);
            GRT[L, C].CResu := sRes[1];
            Result := true;
          end;
        end;
      end;
    end;
  end;

  procedure VerifierXYZ;
  begin
    if PaireDansMemeBloc(sCand2A, Bloc, PositA) and PaireSurMemeLiOuCoHorsBloc(sCand2B, LL, CC, Bloc, PositB) then begin
      if not ((PositA.Li = PositB.Li) or (PositA.Co = PositB.Co)) then begin
        CasesCible(PositB, LL, CC, Bloc);
      end;
    end else
      if PaireDansMemeBloc(sCand2B, Bloc, PositB) and PaireSurMemeLiOuCoHorsBloc(sCand2A, LL, CC, Bloc, PositA) then begin
      if not ((PositA.Li = PositB.Li) or (PositA.Co = PositB.Co)) then begin
        CasesCible(PositA, LL, CC, Bloc);
      end;
    end;
  end;

begin
  Result := False;
  for Bloc := 1 to 9 do begin
    for L := 1 to 3 do begin
      for C := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(Bloc, L, C, LL, CC);
        if GRT[LL, CC].CaseResolue then Continue;
        sCand3 := CandiToStr(GRT[LL, CC].Candidats);
        if length(sCand3) = 3 then begin
          // cas XZ + YZ :
          sCand2A := sCand3[1] + sCand3[3];
          sCand2B := sCand3[2] + sCand3[3]; CandiCommun := sCand3[3];
          VerifierXYZ;
          // cas XY + XZ :
          sCand2A := sCand3[1] + sCand3[2];
          sCand2B := sCand3[1] + sCand3[3]; CandiCommun := sCand3[1];
          VerifierXYZ;
          // cas YZ + YX
          sCand2A := sCand3[2] + sCand3[3];
          sCand2B := sCand3[2] + sCand3[1]; CandiCommun := sCand3[2];
          VerifierXYZ;
        end;
      end;
    end;
  end;
end; // TSudoku.XYZ_Wing

function TSudoku.W_Wing: boolean;
var i, j: byte; PoPaires: TPositions; sCand: shortString; SetPaires: tSetOC;
  Paire1, Paire2, EmplaJ1, EmplaJ2: TPos; cElim: char; OKElim: boolean;
  ResPP, ResEJ: shortString;

  function IDPaires(var PoP: TPositions): byte;
  var L, C: byte;
  begin
    Result := 0; SetLength(PoP, 0); SetPaires := [];
    for L := 1 to 9 do begin
      for C := 1 to 9 do begin
        if GRT[L, C].CaseResolue then Continue;
        sCand := CandiToStr(GRT[L, C].Candidats);
        if length(sCand) = 2 then begin
          inc(Result); SetLength(PoP, Result);
          with PoP[Result - 1] do begin Li := L; Co := C; Cand := GRT[L, C].Candidats; end;
          SetPaires := SetPaires + GRT[L, C].Candidats;
        end;
      end;
    end;
  end;

  function i2iemePaire(const PP: TPos; const ipp: byte; var ips: byte): boolean;
  begin
    Result := false;
    if ipp = High(PoPaires) then EXIT else ips := ipp;
    repeat inc(ips);
      if PoPaires[ips].Cand = PP.Cand then begin Result := true; EXIT; end;
    until Result or (ips = High(PoPaires));
  end;

  function EmplaJumeauxEnLi2(const Li: byte; const Candi: char; var Posit: TPositions): boolean;
  var Occ, np: byte; P: TPositions;
  begin
    Result := False; np := 0; SetLength(Posit, 0);
    Occ := OccPosCandLi(Candi, Li, P);
    if Occ = 2 then begin
      Result := True; inc(np, 2); SetLength(Posit, np);
      Posit[np - 2].Cand := P[0].Cand; Posit[np - 2].Li := P[0].Li; Posit[np - 2].Co := P[0].Co;
      Posit[np - 1].Cand := P[1].Cand; Posit[np - 1].Li := P[1].Li; Posit[np - 1].Co := P[1].Co;
    end;
  end;

  function EmplaJumeauxEnCo2(const Co: byte; const Candi: char; var Posit: TPositions): boolean;
  var Occ, np: byte; P: TPositions;
  begin
    Result := False; np := 0; SetLength(Posit, 0);
    Occ := OccPosCandCo(Candi, Co, P);
    if Occ = 2 then begin
      Result := True; inc(np, 2); SetLength(Posit, np);
      Posit[np - 2].Cand := P[0].Cand; Posit[np - 2].Li := P[0].Li; Posit[np - 2].Co := P[0].Co;
      Posit[np - 1].Cand := P[1].Cand; Posit[np - 1].Li := P[1].Li; Posit[np - 1].Co := P[1].Co;
    end;
  end;

  function EmplaJumeauxEnBloc2(const Bloc: byte; const Candi: char; var Posit: TPositions): boolean;
  var Occ, np: byte; P: TPositions;
  begin
    Result := False; np := 0; SetLength(Posit, 0);
    Occ := OccPosCandBloc(Candi, Bloc, P);
    if Occ = 2 then begin
      Result := True; inc(np, 2); SetLength(Posit, np);
      Posit[np - 2].Cand := P[0].Cand; Posit[np - 2].Li := P[0].Li; Posit[np - 2].Co := P[0].Co;
      Posit[np - 1].Cand := P[1].Cand; Posit[np - 1].Li := P[1].Li; Posit[np - 1].Co := P[1].Co;
    end;
  end;

  function EJ1AligneAvecPP1ouPP2etEJ2AliAvecPP2ouPP1(const PP1, PP2: TPos; const EJ1, EJ2: TPos): boolean;
  begin
    Result := (EJ1.Li = PP1.Li) and (EJ2.Li = PP2.Li)
      or (EJ1.Li = PP2.Li) and (EJ2.Li = PP1.Li)
      or (EJ1.Co = PP1.Co) and (EJ2.Co = PP2.Co)
      or (EJ1.Co = PP2.Co) and (EJ2.Co = PP1.Co)
  end;

  function EJ1ouEJ2SurCasesPP1ouPP2(const PP1, PP2: TPos; const EJ1, EJ2: TPos): boolean;
  begin
    Result := false;
    if ((PP1.Li = EJ1.Li) and (PP1.Co = EJ1.Co)) // PP1 concide avec EJ1
      or ((PP1.Li = EJ2.Li) and (PP1.Co = EJ2.Co)) // PP1 concide avec EJ2
      or ((PP2.Li = EJ1.Li) and (PP2.Co = EJ1.Co)) // PP2 concide avec EJ1
      or ((PP2.Li = EJ2.Li) and (PP2.Co = EJ2.Co)) // PP2 concide avec EJ2
      then Result := true;
  end;

  function EstW_Wing(const PP1, PP2: TPos; var EJ1, EJ2: TPos): boolean;
  var i, L, C, B: byte; Candi: char; PJ: TPositions;
  begin
    Result := False;
    if NumBloc(PP1.Li, PP1.Co) = NumBloc(PP2.Li, PP2.Co) then EXIT; //
    sCand := CandiToStr(PP1.Cand);
    for i := 1 to 2 do begin
      Candi := sCand[i];
      // Cas EmplaJumeauxEnCo
      for C := 1 to 9 do begin
        if EmplaJumeauxEnCo2(C, Candi, PJ) then begin
          // Eviter emplas jumeaux qui coincideraient avec les cases des Paires :
          if EJ1ouEJ2SurCasesPP1ouPP2(PP1, PP2, PJ[0], PJ[1])
            or (not EJ1AligneAvecPP1ouPP2etEJ2AliAvecPP2ouPP1(PP1, PP2, PJ[0], PJ[1])) then Continue;
          Result := true;
          with EJ1 do begin Li := PJ[0].Li; Co := PJ[0].Co; Cand := PJ[0].Cand; end;
          with EJ2 do begin Li := PJ[1].Li; Co := PJ[1].Co; Cand := PJ[1].Cand; end;
          if i = 1 then cElim := sCand[2] else cElim := sCand[1];
          EXIT;
        end;
      end;
      // Cas EmplaJumeauxEnLi
      for L := 1 to 9 do begin
        if EmplaJumeauxEnLi2(L, Candi, PJ) then begin
          if EJ1ouEJ2SurCasesPP1ouPP2(PP1, PP2, PJ[0], PJ[1])
            or (not EJ1AligneAvecPP1ouPP2etEJ2AliAvecPP2ouPP1(PP1, PP2, PJ[0], PJ[1])) then Continue;
          Result := true;
          with EJ1 do begin Li := PJ[0].Li; Co := PJ[0].Co; Cand := PJ[0].Cand; end;
          with EJ2 do begin Li := PJ[1].Li; Co := PJ[1].Co; Cand := PJ[1].Cand; end;
          if i = 1 then cElim := sCand[2] else cElim := sCand[1];
          EXIT;
        end;
      end;
      // Cas EmplaJumeauxEnBloc
      for B := 1 to 9 do begin
        if EmplaJumeauxEnBloc2(B, Candi, PJ) then begin
          if EJ1ouEJ2SurCasesPP1ouPP2(PP1, PP2, PJ[0], PJ[1])
            or (not EJ1AligneAvecPP1ouPP2etEJ2AliAvecPP2ouPP1(PP1, PP2, PJ[0], PJ[1])) then Continue;
          Result := true;
          with EJ1 do begin Li := PJ[0].Li; Co := PJ[0].Co; Cand := PJ[0].Cand; end;
          with EJ2 do begin Li := PJ[1].Li; Co := PJ[1].Co; Cand := PJ[1].Cand; end;
          if i = 1 then cElim := sCand[2] else cElim := sCand[1];
          EXIT;
        end;
      end;
    end;
  end; // EstW_Wing

  procedure BaliserCases(const WElim: char; const Cases: TPositions);
  var ic, L, C: byte;
  begin
    for ic := 0 to High(Cases) do begin
      L := Cases[ic].Li; C := Cases[ic].Co;
      if WElim in GRT[L, C].Candidats then begin
        GRT[L, C].CElim := WElim; OKElim := true;
        GRT[L, C].Info := Format('en L%dC%d car W-Wing avec : %s', [L, C, ResPP + ResEJ]);
        Trace('Candidat ' + WElim + GRT[L, C].Info);
      end;
    end;
  end;

  procedure BaliserEliminables(const WElim: char; const PP1, PP2, EJ1, EJ2: TPos);
  var B1, B2, LB, CB, L, C: byte; Cases: TPositions;
  begin
    ResPP := Format(#13#10 + '- Paires %s en L%dC%d et L%dC%d', [CandiToStr(PP1.Cand), PP1.Li, PP1.Co, PP2.Li, PP2.Co]);
    ResEJ := Format(#13#10 + '- Emplacements jumeaux du %s en L%dC%d et L%dC%d', [CandiToStr(EJ1.Cand), EJ1.Li, EJ1.Co, EJ2.Li, EJ2.Co]);
    SetLength(Cases, 0);
    // Mini = sur intersections :
    if (PP1.Li <> PP2.Li) and (PP1.Co <> PP2.Co) then begin
      SetLength(Cases, 2);
      Cases[0].Li := PP1.Li; Cases[0].Co := PP2.Co;
      Cases[1].Li := PP2.Li; Cases[1].Co := PP1.Co;
    end;
    B1 := NumBloc(PP1.Li, PP1.Co); B2 := NumBloc(PP2.Li, PP2.Co);
    for LB := 1 to 3 do begin
      for CB := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(B1, LB, CB, L, C);
        if ((L = PP1.Li) and (C = PP1.Co)) or ((L = PP2.Li) and (C = PP2.Co)) then Continue;
        if (L = PP2.Li) or (C = PP2.Co) then begin
          SetLength(Cases, Length(Cases) + 1);
          Cases[Length(Cases) - 1].Li := L; Cases[Length(Cases) - 1].Co := C;
        end;
      end;
    end;
    for LB := 1 to 3 do begin
      for CB := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(B2, LB, CB, L, C);
        if ((L = PP1.Li) and (C = PP1.Co)) or ((L = PP2.Li) and (C = PP2.Co)) then Continue;
        if (L = PP1.Li) or (C = PP1.Co) then begin
          SetLength(Cases, Length(Cases) + 1);
          Cases[Length(Cases) - 1].Li := L; Cases[Length(Cases) - 1].Co := C;
        end;
      end;
    end;
    if Length(Cases) <> 0 then BaliserCases(WElim, Cases);
  end;


begin
  Result := False;
  if IDPaires(PoPaires) < 2 then begin trace('W_Wing : Pas assez de Paires'); EXIT; end;
  for i := 0 to high(PoPaires) do begin //Trace('Paire ' + CandiToStr(PoPaires[i].Cand));
    Paire1 := PoPaires[i];
    j := i;
    if i2iemePaire(Paire1, j, j) then begin
      Paire2 := PoPaires[j];
      if EstW_Wing(Paire1, Paire2, EmplaJ1, EmplaJ2) then begin
        BaliserEliminables(cElim, Paire1, Paire2, EmplaJ1, EmplaJ2);
        Result := OKElim;
      end;
    end;
  end;
end; // TSudoku.W_Wing

function TSudoku.Y_Wing: boolean;
var i, ip1: SmallInt; PoPairesXZ: TPositions; sCand, Align: shortString; SetPaires, SetYElim: tSetOC;
  Paire1, XY, ZY: TPos; YElim: char; OKElim: boolean;
  ResXZ, ResXY, ResZY: ShortString;
  Paires2, Paires3: TPositions;

  function IDPaires(var PoP: TPositions): byte;
  var L, C: byte;
  begin
    Result := 0; SetLength(PoP, 0); SetPaires := [];
    for L := 1 to 9 do begin
      for C := 1 to 9 do begin
        if GRT[L, C].CaseResolue then Continue;
        sCand := CandiToStr(GRT[L, C].Candidats);
        if length(sCand) = 2 then begin
          inc(Result); SetLength(PoP, Result);
          with PoP[Result - 1] do begin Li := L; Co := C; Cand := GRT[L, C].Candidats; end;
          SetPaires := SetPaires + GRT[L, C].Candidats;
        end;
      end;
    end;
  end;

  function CombinerPaires(const it: byte; const PaireXZ: TPos; var pXY, pZY: TPositions): boolean;
  var sCand1, sCand2: shortString; X, Y, Z: char; Jeu, XY, ZY: tSetOC; i: byte; okXY, okZY: boolean;
  begin
    sCand1 := CandiToStr(PaireXZ.Cand);
    X := sCand1[1]; Z := sCand1[2]; // Clef = XY issue de PP
    // Y:=Tout sauf X et Z :
    Jeu := SetResOK; Jeu := Jeu - [X] - [Z];
    sCand2 := CandiToStr(Jeu);
    Y := sCand2[it]; XY := [X] + [Y]; ZY := [Z] + [Y];
    SetLength(pXY, 0); SetLength(pZY, 0);
    // Vrif existence :
    okXY := false; okZY := false;
    for i := 0 to High(PoPairesXZ) do if PoPairesXZ[i].Cand = XY then begin
        okXY := true; SetLength(pXY, length(pXY) + 1);
        pXY[length(pXY) - 1].Cand := XY; pXY[length(pXY) - 1].Li := PoPairesXZ[i].Li; pXY[length(pXY) - 1].Co := PoPairesXZ[i].Co;
      end;
    for i := 0 to High(PoPairesXZ) do if PoPairesXZ[i].Cand = ZY then begin
        okZY := true; SetLength(pZY, length(pZY) + 1);
        pZY[length(pZY) - 1].Cand := ZY; pZY[length(pZY) - 1].Li := PoPairesXZ[i].Li; pZY[length(pZY) - 1].Co := PoPairesXZ[i].Co;
      end;
    Result := okXY and okZY;
    if not Result then begin
      SetLength(pXY, 0); SetLength(pZY, 0);
    end;
  end;

  { Y-Wing : configuration de 3 cases  2 candidats XZ, XY, et ZY disposes :
    - soit en querre,
    - soit avec XZ avec l'une des deux autres dans le mme bloc et l'autre aligne avec XZ,
    - soit avec XZ seul dans un bloc et l'autre aligne avec ZY et XY runis dans un autre bloc.}

  function EstYWing(const PaireXZ: TPos; const pXY, pZY: TPositions; var XY, ZY: TPos; var Ali: ShortString): boolean;
  var ipXY, ipZY: byte;
  begin
    Result := false;
    for ipXY := 0 to high(pXY) do begin
      for ipZY := 0 to high(pZY) do begin
        Ali := '';
        Result := false;
        if EnEquerre(PaireXZ, pXY[ipXY], pZY[ipZY]) then begin
          Ali := 'Equerre'; Result := true;
        end;
        if (Ali = '') and DeuxDansMemeBloc(PaireXZ, pXY[ipXY]) and DeuxAlignes(PaireXZ, pZY[ipZY]) then begin
          Result := true; Ali := 'XZ-ZY'; // ZY align avec clef
        end;
        if (Ali = '') and DeuxDansMemeBloc(PaireXZ, pZY[ipZY]) and DeuxAlignes(PaireXZ, pXY[ipXY]) then begin
          Result := true; Ali := 'XZ-XY'; // XY align avec clef
        end;
        if (Ali = '') and DeuxDansMemeBloc(pZY[ipZY], pXY[ipXY]) and TroisAlignes(PaireXZ, pZY[ipZY], pXY[ipXY]) then begin
          Result := true; Ali := '3-Aligns';
        end;
        if Result then begin
          XY.Cand := pXY[ipXY].Cand; XY.Li := pXY[ipXY].Li; XY.Co := pXY[ipXY].Co;
          ZY.Cand := pZY[ipZY].Cand; ZY.Li := pZY[ipZY].Li; ZY.Co := pZY[ipZY].Co;
          EXIT;
        end;
      end;
    end;
  end; // EstYWing

  procedure BaliserCase(const WElim: char; const L, C: byte);
  begin
    if WElim in GRT[L, C].Candidats then begin
      GRT[L, C].CElim := WElim; OKElim := true;
      GRT[L, C].Info := Format('en L%dC%d car Y-Wing : %s', [L, C, ResXZ + ResXY + ResZY]);
    end;
  end;

  procedure BaliserEliminables(const YElim: char; const PoXZ, PoXY, PoZY: TPos; const Ali: ShortString);
  var L, C, B1, B2, B3, BU, LB, CB, La, Ca: byte;

    function NiSurXZ_XY_ZY(const L, C: byte): boolean;
    begin
      if ((PoXZ.Li = L) and (PoXZ.Co = C))
        or ((PoXY.Li = L) and (PoXY.Co = C))
        or ((PoZY.Li = L) and (PoZY.Co = C)) then Result := false else Result := true;
    end;

  begin
    ResXZ := Format(#13#10 + '- XZ %s en L%dC%d', [CandiToStr(PoXZ.Cand), PoXZ.Li, PoXZ.Co]);
    ResXY := Format(#13#10 + '- XY %s en L%dC%d', [CandiToStr(PoXY.Cand), PoXY.Li, PoXY.Co]);
    ResZY := Format(#13#10 + '- ZY %s en L%dC%d', [CandiToStr(PoZY.Cand), PoZY.Li, PoZY.Co]);
    if Ali = 'Equerre' then begin
      if PoXZ.Co = PoXY.Co then begin C := PoZY.Co; L := PoXY.Li; end else
        if PoXZ.Co = PoZY.Co then begin C := PoXY.Co; L := PoZY.Li; end;
      BaliserCase(YElim, L, C); EXIT;
    end;
    B1 := NumBloc(PoXZ.Li, PoXZ.Co); B2 := NumBloc(PoXY.Li, PoXY.Co); B3 := NumBloc(PoZY.Li, PoZY.Co);
    BU := B3;
    if B1 = B2 then BU := B3 else if B1 = B3 then BU := B2;
    if (Ali = 'XZ-XY') or (Ali = '3-Aligns') then begin
      La := 0; Ca := 0;
      // Dans bloc de XZ :
      if PoXZ.Li = PoXY.Li then La := PoXZ.Li else
        if PoXZ.Co = PoXY.Co then Ca := PoXZ.Co;
      for LB := 1 to 3 do begin
        for CB := 1 to 3 do begin
          LiCoDeLiBlocCoBloc(B1, LB, CB, L, C);
          if (La <> 0) and (L = La) and NiSurXZ_XY_ZY(L, C) then BaliserCase(YElim, L, C) else
            if (Ca <> 0) and (C = Ca) and NiSurXZ_XY_ZY(L, C) then BaliserCase(YElim, L, C);
        end;
      end;
      // Dans l'autre bloc :
      if La <> 0 then La := PoZY.Li else
        if Ca <> 0 then Ca := PoZY.Co;
      for LB := 1 to 3 do begin
        for CB := 1 to 3 do begin
          LiCoDeLiBlocCoBloc(BU, LB, CB, L, C);
          if (La <> 0) and (L = La) and NiSurXZ_XY_ZY(L, C) then BaliserCase(YElim, L, C) else
            if (Ca <> 0) and (C = Ca) and NiSurXZ_XY_ZY(L, C) then BaliserCase(YElim, L, C);
        end;
      end;
    end;
    if (Ali = 'XZ-ZY') or (Ali = '3-Aligns') then begin
      La := 0; Ca := 0;
      // Dans bloc de XZ :
      if PoXZ.Li = PoZY.Li then La := PoXZ.Li else
        if PoXZ.Co = PoZY.Co then Ca := PoXZ.Co;
      for LB := 1 to 3 do begin
        for CB := 1 to 3 do begin
          LiCoDeLiBlocCoBloc(B1, LB, CB, L, C);
          if (La <> 0) and (L = La) and NiSurXZ_XY_ZY(L, C) then BaliserCase(YElim, L, C) else
            if (Ca <> 0) and (C = Ca) and NiSurXZ_XY_ZY(L, C) then BaliserCase(YElim, L, C);
        end;
      end;
      // Dans l'autre bloc :
      if La <> 0 then La := PoXY.Li else
        if Ca <> 0 then Ca := PoXY.Co;
      for LB := 1 to 3 do begin
        for CB := 1 to 3 do begin
          LiCoDeLiBlocCoBloc(BU, LB, CB, L, C);
          if (La <> 0) and (L = La) and NiSurXZ_XY_ZY(L, C) then BaliserCase(YElim, L, C) else
            if (Ca <> 0) and (C = Ca) and NiSurXZ_XY_ZY(L, C) then BaliserCase(YElim, L, C);
        end;
      end;
    end;
  end; // BaliserEliminables

begin
  Result := False; OKElim := false;
  if IDPaires(PoPairesXZ) < 3 then trace('Y_Wing : Pas assez de Paires');
  for ip1 := 0 to high(PoPairesXZ) do begin
    Paire1 := PoPairesXZ[ip1];
    for i := 1 to 7 do begin
      if CombinerPaires(i, Paire1, Paires2, Paires3) then begin
        if EstYWing(Paire1, Paires2, Paires3, XY, ZY, Align)
          then begin
          SetYElim := XY.Cand * ZY.Cand;
          YElim := CandiToStr(SetYElim)[1];
          BaliserEliminables(YElim, Paire1, XY, ZY, Align);
          Result := OKElim;
        end;
      end;
    end;
  end;
end; // TSudoku.Y_Wing

function TSudoku.GetCandLi(const Li: byte): tSetOC;
var C: byte;
begin
  Result := [];
  for C := 1 to 9 do Result := Result + GRT[Li, C].Candidats;
end;

function TSudoku.GetCandCo(const Co: byte): tSetOC;
var L: byte;
begin
  Result := [];
  for L := 1 to 9 do Result := Result + GRT[L, Co].Candidats;
end;

function TSudoku.GetCandBloc(const Bl: byte): tSetOC;
var LiB, CoB, L, C: byte;
begin
  Result := [];
  for LiB := 1 to 3 do begin
    for CoB := 1 to 3 do begin
      LiCoDeLiBlocCoBloc(Bl, LiB, CoB, L, C);
      Result := Result + GRT[L, C].Candidats;
    end;
  end;
end;

procedure TSudoku.ModifManuCandis(Candis: ShortString; Li, Co: byte; Modif: char);
var Scand: string; po: integer; ic: byte;

  procedure BaliserCandiOuEmplaUniqueSurLiOuCo(const Li, Co: byte; const CandElim: char);
  var sCand: string; Bloc, OccLi, occCo, OccBlo: byte; Posit: TPositions;
  begin
    Bloc := NumBloc(Li, Co);
    sCand := CandiToStr(GRT[Li, Co].Candidats);
    if length(sCand) = 1 then begin // Candi = Unique
      GRT[Li, Co].Info := Format(' Candidat %s = Rsulat pour L%dC%d car Unique dans cette case', [sCand[1], Li, Co]);
      GRT[Li, Co].CResu := CandElim;
    end;
    OccLi := OccPosCandLi(CandElim, Li, Posit);
    if (OccLi = 1) then begin // Emplacement unique
      GRT[Li, Posit[0].Co].Info := Format(' Candidat %s = Rsulat pour L%dC%d car en Emplacement unique sur Ligne', [CandElim, Li, Posit[0].Co]);
      GRT[Li, Posit[0].Co].CResu := CandElim;
    end;
    occCo := OccPosCandCo(CandElim, Co, Posit);
    if (occCo = 1) then begin // Emplacement unique
      GRT[Posit[0].Li, Co].Info := Format(' Candidat %s = Rsulat pour L%dC%d car en Emplacement unique sur Colonne', [CandElim, Posit[0].Li, Co]);
      GRT[Posit[0].Li, Co].CResu := CandElim;
    end;
    OccBlo := OccPosCandBloc(CandElim, Bloc, Posit);
    if (OccBlo = 1) then begin // Emplacement unique
      GRT[Posit[0].Li, Posit[0].Co].Info := Format(' Candidat %s = Rsulat pour L%dC%d car en Emplacement unique dans Bloc %d', [CandElim, Posit[0].Li, Posit[0].Co, Bloc]);
      GRT[Posit[0].Li, Posit[0].Co].CResu := CandElim;
    end;
  end; // BaliserCandiOuEmplaUniqueSurLiOuCo

begin
  case Modif of
    'S': begin
        sCand := CandiToStr(GRT[Li, Co].Candidats);
        if length(sCand) = 1 then begin
          sms(sCand + ' = Candidat unique : Non supprimable (Seulement Remplaable)');
          EXIT;
        end;
        for ic := 1 to length(Candis) do begin
          GRT[Li, Co].Candidats := GRT[Li, Co].Candidats - [Candis[ic]];
          po := pos(Candis[ic], GRT[Li, Co].CElim);
          if po > 0 then Delete(GRT[Li, Co].CElim, po, 1);
          BaliserCandiOuEmplaUniqueSurLiOuCo(Li, Co, Candis[ic]);
          if GRT[Li, Co].CElim = '' then GRT[Li, Co].Info := '';
        end;
      end;
    'A': begin
        GRT[Li, Co].Candidats := GRT[Li, Co].Candidats + [Candis[1]];
        GRT[Li, Co].Info := '';
      end;
  end;
end;

procedure TSudoku.ModifManuValRes(NewVal: Char; Li, Co: byte; Modif: char); //<= Modif = R pour Remplacer et S pour Supprimer
var L, C, B, LiB, CoB: byte;
  SetLignesRes, SetColonnesRes, SetBlocRes: array[1..9] of tSetOC; // ['1'..'9']

  function SetResLi(LL: byte): tSetOC;
  var i: byte;
  begin
    Result := [];
    for i := 1 to 9 do begin
      if GRT[LL, i].CaseResolue then Result := Result + [GRT[LL, i].ValReso];
    end;
  end;

  function SetResCo(CC: byte): tSetOC;
  var i: byte;
  begin
    Result := [];
    for i := 1 to 9 do begin
      if GRT[i, CC].CaseResolue then Result := Result + [GRT[i, CC].ValReso];
    end;
  end;

  function SetResBloc(BB: byte): tSetOC;
  var i, j: byte;
  begin
    Result := [];
    for i := 1 to 3 do begin
      for j := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(BB, i, j, L, C);
        if GRT[L, C].CaseResolue then Result := Result + [GRT[L, C].ValReso];
      end;
    end;
  end;

begin
  case Modif of
    'R': begin // Remplacement
        GRT[Li, Co].ValReso := NewVal;
      end;
    'S': begin // Suppression
        GRT[Li, Co].ValReso := #0;
        GRT[Li, Co].CaseResolue := False;
        GRT[Li, Co].CoulCase := clBlack;
        GrilleResolue := False;
      end;
  end;

  for L := 1 to 9 do SetLignesRes[L] := SetResLi(L);
  for C := 1 to 9 do SetColonnesRes[C] := SetResCo(C);
  for B := 1 to 9 do SetBlocRes[B] := SetResBloc(B);

  for B := 1 to 9 do begin
    for LiB := 1 to 3 do begin
      for CoB := 1 to 3 do begin
        LiCoDeLiBlocCoBloc(B, LiB, CoB, L, C);
        if not GRT[L, C].CaseResolue then begin
          GRT[L, C].Candidats := SetResOk - SetLignesRes[L] - SetColonnesRes[C] - SetBlocRes[B];
        end;
      end;
    end;
  end;
  NCRes := 0;
  for L := 1 to 9 do begin
    for C := 1 to 9 do begin
      if GRT[L, C].CaseResolue then inc(NCRes);
    end;
  end;
  GrilleMem1 := GrilleClone(GRT);
end; // TSudoku.ModifManuValRes

// Affichages :

procedure TSudoku.RAZGrille;
var li, co: integer;
begin
  NCRes := 0;
  for Li := 1 to 9 do begin
    for Co := 1 to 9 do begin
      with GRT[li, co] do begin
        ValReso := #0; CaseResolue := False; CoulCase := 0; Candidats := []; ;
        NumRes := 0; Info := ''; CElim := ''; CResu := '*'; clFond := 2;
      end;
      if Odd(NumBloc(Li, Co)) then Grid.Canvas.Brush.Color := clAqua
      else Grid.Canvas.Brush.Color := clWhite;
      Grid.Canvas.FillRect(Grid.CellRect(li - 1, co - 1));
    end;
  end;
end;

procedure TSudoku.ViderGrilleInitCandi;
var Li, Co: byte;
begin
  RAZGrille;
  for Li := 1 to 9 do begin
    for Co := 1 to 9 do begin
      with GRT[Li, Co] do Candidats := SetResOK;
    end;
  end;
  GrilleChargee := True;
  RaffraichirAffichageCandidats;
end;

procedure TSudoku.AffCase(Val: Char; Li, Co: byte);
var R: tRect;
begin
  with Grid do
  begin
    if Odd(NumBloc(Li, Co)) then Canvas.Brush.Color := clAqua
    else Canvas.Brush.Color := clWhite;
    R := CellRect(Co - 1, Li - 1);
    Canvas.FillRect(R);
    // Quadrillage :
    Canvas.pen.color := clGray;
    Canvas.pen.width := 1;
    Canvas.MoveTo(R.Right, R.Bottom); Canvas.LineTo(R.Right, R.Top - 1);
    Canvas.MoveTo(R.Left, R.Bottom); Canvas.LineTo(R.Right, R.Bottom);
    Canvas.pen.color := clBlack;
    if Li mod 3 = 0 then begin
      Canvas.MoveTo(R.Left-1, R.Bottom); Canvas.LineTo(R.Right, R.Bottom);
    end;
    if Co mod 3 = 0 then begin
      Canvas.MoveTo(R.Right, R.Bottom); Canvas.LineTo(R.Right, R.Top - 1);
    end;
    Canvas.MoveTo(0, 0); Canvas.LineTo(0, Width - 5);
    Canvas.MoveTo(0, 0); Canvas.LineTo(Height - 5, 0);
    // Texte :
    Canvas.Font.Color := GRT[Li, Co].CoulCase;
    Canvas.Brush.Style := bsClear;
    Canvas.Font.Name := 'Impact';
    Canvas.Font.Size := 18;
    Canvas.Font.Style := [fsBold];
    R := CellRect(Co - 1, Li - 1);
    Canvas.TextOut(R.Left + 12, R.Top + 6, Val);
    Canvas.Font.Name := 'Courrier new';
    Canvas.Font.Size := 7;
    Canvas.TextOut(R.Left + 12, R.Top + 32, intToStr(GRT[Li, Co].NumRes));
  end;
end;

procedure TSudoku.AffCandi(const Li, Co: integer; const clFond: tColor);
    // <- Si clFond = 2 alors couleurs alternes clWhite/clAqua sinon case de couleur clFond
var R: tRect; i: byte; c: Char;
  wd, hd, mah, mag, dx, dy, cc, x, y: integer;
begin
  if GRT[li, co].CaseResolue then EXIT;
  if GRT[li, co].CoulCase = clResManu then EXIT;
  with Grid do
  begin
    Canvas.Brush.Style := bsSolid;
    // Couleur de Fond cas gnral :
    if GRT[Li, Co].clFond = 2 then begin
      if Odd(NumBloc(Li, Co)) then Canvas.Brush.Color := clAqua
      else Canvas.Brush.Color := clWhite;
    end else Canvas.Brush.Color := clFond;
    // Couleur de Fond cas particuliers :
    if GRT[Li, Co].CResu <> '*' then Canvas.Brush.Color := clCandiResultat else
      if GRT[Li, Co].CElim <> '' then Canvas.Brush.Color := clCandiSupprimable else
      if GRT[Li, Co].clFond <> 2 then Canvas.Brush.Color := GRT[Li, Co].clFond;

    R := CellRect(Co - 1, Li - 1);
    Canvas.FillRect(R);

    // Quadrillage :
    Canvas.pen.color := clGray;
    Canvas.pen.width := 1;
    Canvas.MoveTo(R.Right, R.Bottom); Canvas.LineTo(R.Right, R.Top - 1);
    Canvas.MoveTo(R.Left, R.Bottom); Canvas.LineTo(R.Right, R.Bottom);
    Canvas.pen.color := clBlack;
    if Li mod 3 = 0 then begin
      Canvas.MoveTo(R.Left-1, R.Bottom); Canvas.LineTo(R.Right, R.Bottom);
    end;
    if Co mod 3 = 0 then begin
      Canvas.MoveTo(R.Right, R.Bottom); Canvas.LineTo(R.Right, R.Top - 1);
    end;
    Canvas.MoveTo(0, 0); Canvas.LineTo(0, Width - 5);
    Canvas.MoveTo(0, 0); Canvas.LineTo(Height - 5, 0);
    // Texte :
    Canvas.Font.Name := 'Arial'; Canvas.Brush.Style := bsClear;
    cc := R.Right - R.Left;
    wd := 6; hd := 8; mah := (cc - 3 * hd) div 4; mag := (cc - 3 * wd) div 4;  
    dx := wd + mag; dy := hd + mah;
    for i := 1 to 9 do begin
      c := Chr(48 + i);
      x := R.Left; y := R.Top; case c of
        '1': begin x := x + mag; y := y + mah; end;
        '2': begin x := x + mag + dx; y := y + mah; end;
        '3': begin x := x + mag + 2 * dx; y := y + mah; end;

        '4': begin x := x + mag; y := y + mah + dy; end;
        '5': begin x := x + mag + dx; y := y + mah + dy; end;
        '6': begin x := x + mag + 2 * dx; y := R.Top + mah + dy; end;

        '7': begin x := x + mag; y := y + mah + 2 * dy; end;
        '8': begin x := x + mag + dx; y := y + mah + 2 * dy; ; end;
        '9': begin x := x + mag + 2 * dx; y := y + mah + 2 * dy; end;
      end;
      Canvas.Font.Size := 8; Canvas.Font.Color := clBlack; Canvas.Font.Style := [fsBold];
      if pos(c, sCandiIllumine) > 0 then begin
        Canvas.Font.Size := 9; Canvas.Font.Color := clRed; Canvas.Font.Style := [fsBold];
      end;
      if (c in GRT[li, co].Candidats) then Canvas.TextOut(x, y-1, c);
    end;
  end;
end; // AffCandi( Li, Co: integer);

procedure TSudoku.RaffraichirAffichageCandidats;
var Li, Co: byte;
begin
  for li := 1 to 9 do for co := 1 to 9 do AffCandi(Li, Co, 2);
end;

procedure TSudoku.RaffraichirAffichageGrille;
var Li, Co: byte;
begin
  for li := 1 to 9 do for co := 1 to 9 do begin
      if GRT[Li, Co].CaseResolue
        then AffCase(GRT[Li, Co].ValReso, Li, Co)
      else AffCandi(Li, Co, GRT[Li, Co].clFond);
    end;
end;

function TSudoku.ErrCaseVideNonResolue: boolean;
// Result = True si Case non rsolue et vide de ses candidats
var Li, Co: byte;
begin
  for Li := 1 to 9 do begin
    for Co := 1 to 9 do begin
      Result := (not (GRT[li, co].CaseResolue)) and (GRT[li, co].Candidats = []);
      if Result then EXIT;
    end;
  end;
end;

function TSudoku.ErrValResDoublon: boolean;
// Result = True si Rsultat-Doublon dans une ligne, colonne, ou bloc.

  function ResDoublonSurLig: boolean;
  var i, Li, Co, Occ: byte; SetRes: tSetOC; sRes: string;
  begin
    Result := False;
    for Li := 1 to 9 do begin
      SetRes := SetResOK - GetCandLi(Li);
      sRes := CandiToStr(SetRes);
      for i := 1 to length(sRes) do begin
        Occ := 0;
        for Co := 1 to 9 do begin
          if GRT[li, co].CaseResolue and (GRT[li, co].ValReso = sRes[i]) then inc(Occ);
          Result := Occ >= 2;
          if Result then begin
            EXIT; end;
        end;
      end;
    end;
  end;

  function ResDoublonSurCol: boolean;
  var i, Li, Co, Occ: byte; SetRes: tSetOC; sRes: string;
  begin
    Result := False;
    for Co := 1 to 9 do begin
      SetRes := SetResOK - GetCandCo(Co);
      sRes := CandiToStr(SetRes);
      for i := 1 to length(sRes) do begin
        Occ := 0;
        for Li := 1 to 9 do begin
          if GRT[li, co].CaseResolue and (GRT[li, co].ValReso = sRes[i]) then inc(Occ);
          Result := Occ >= 2;
          if Result then begin
            EXIT; end;
        end;
      end;
    end;
  end;

  function ResDoublonDansBloc: boolean;
  var i, Bloc, LiB, CoB, Li, Co, Occ: byte; SetRes: tSetOC; sRes: string;
  begin
    Result := False;
    for Bloc := 1 to 9 do begin
      SetRes := SetResOK - GetCandBloc(Bloc);
      sRes := CandiToStr(SetRes);
      for i := 1 to length(sRes) do begin
        Occ := 0;
        for LiB := 1 to 3 do begin
          for CoB := 1 to 3 do begin
            LiCoDeLiBlocCoBloc(Bloc, LiB, CoB, Li, Co);
            if GRT[li, co].CaseResolue and (GRT[li, co].ValReso = sRes[i]) then inc(Occ);
            Result := Occ >= 2;
            if Result then begin
              EXIT; end;
          end;
        end;
      end;
    end;
  end;

begin
  Result := ResDoublonSurLig; if Result then EXIT;
  Result := ResDoublonSurCol; if Result then EXIT;
  Result := ResDoublonDansBloc;
end;

function TSudoku.ControleRes: string;
var info: string;

  function CtrlResParLig: boolean;
  var Li, Co, Occ: byte; SetRes: tSetOC;
  begin
    Occ := 0;
    for Li := 1 to 9 do begin
      SetRes := [];
      for Co := 1 to 9 do begin
        if GRT[li, co].CaseResolue then begin
          if not (GRT[li, co].ValReso in SetRes)
            then SetRes := SetRes + [GRT[li, co].ValReso];
        end;
      end;
      if SetRes = SetResOK then inc(Occ) else info := info + ' L' + intToStr(Li);
    end;
    Result := Occ = 9;
  end;

  function CtrlResParCol: boolean;
  var Li, Co, Occ: byte; SetRes: tSetOC;
  begin
    Occ := 0;
    for Co := 1 to 9 do begin
      SetRes := [];
      for Li := 1 to 9 do begin
        if GRT[li, co].CaseResolue then begin
          if not (GRT[li, co].ValReso in SetRes)
            then SetRes := SetRes + [GRT[li, co].ValReso];
        end;
      end;
      if SetRes = SetResOK then inc(Occ) else info := info + ' C' + intToStr(Co);
    end;
    Result := Occ = 9;
  end;

  function CtrlResParBloc: boolean;
  var Bloc, Li, Co, LiBloc, CoBloc, Occ: byte; SetRes: tSetOC;
  begin
    Occ := 0;
    for Bloc := 1 to 9 do begin
      SetRes := [];
      for LiBloc := 1 to 3 do begin
        for CoBloc := 1 to 3 do begin
          LiCoDeLiBlocCoBloc(Bloc, LiBloc, CoBloc, Li, Co);
          if GRT[li, co].CaseResolue then begin
            if not (GRT[li, co].ValReso in SetRes)
              then SetRes := SetRes + [GRT[li, co].ValReso];
          end;
        end;
      end;
      if SetRes = SetResOK then inc(Occ) else info := info + ' Bloc' + intToStr(Bloc);
    end;
    Result := Occ = 9;
  end;

begin
  info := 'Contrle : PAS OK, ou PAS FINI en';
  if CtrlResParLig and CtrlResParCol and CtrlResParBloc then Result := 'Contrle : OK' else Result := info;
end;

function TSudoku.SLGrille: tStringList;
var Li, Co: byte; s: string;
begin
  Result := tStringList.Create;
  for Li := 1 to 9 do begin
    s := '';
    for Co := 1 to 9 do begin
      if GRT[Li, Co].CaseResolue
        then s := s + GRT[Li, Co].ValReso else s := s + '0';
    end;
    Result.Add(s);
  end;
end;

function TSudoku.GrillePermuterCo1Co2(const Co1, Co2: byte): tStringList;
var Li: byte; s: string;

  procedure PermuteCar(var ch: string; i, j: byte);
  var car: char;
  begin
    if i <> j then begin
      car := ch[i]; ch[i] := ch[j]; ch[j] := car;
    end
  end;

begin
  Result := SLGrille;
  for Li := 0 to 8 do begin
    S := Result[Li]; PermuteCar(s, Co1, Co2);
    Result[Li] := S;
  end;
end; // TSudoku.GrillePermuterCo1Co2

function TSudoku.GrillePermuterLi1Li2(const Li1, Li2: byte): tStringList;
var s: string;
begin
  Result := SLGrille;
  S := Result[Li1 - 1]; Result[Li1 - 1] := Result[Li2 - 1]; Result[Li2 - 1] := S;
end; // TSudoku.GrillePermuterLi1Li2

function TSudoku.GrillePermuterGD: tStringList;
var s: string; i: byte;
begin
  Result := SLGrille;
  for i := 0 to 8 do begin
    S := Result[i];
    S := ReverseString(Result[i]);
    Result[i] := S;
  end;
end; // TSudoku.GrillePermuterGD

function TSudoku.GrillePermuterHB: tStringList;
var s: string; i: byte;
begin
  Result := SLGrille;
  for i := 0 to 3 do begin
    S := Result[i]; Result[i] := Result[8 - i]; Result[8 - i] := S;
  end;
end; // TSudoku.GrillePermuterHB

function TSudoku.GrillePermuterLiCo: tStringList;
var Li, Co: byte; Perm: array[0..8] of string;
begin
  Result := SLGrille;
  for Li := 0 to 8 do begin
    for Co := 1 to 9 do begin
      SetLength(Perm[Co - 1], 9);
      Perm[Co - 1, Li + 1] := SLGrille[Li][Co];
    end;
  end;
  for Li := 0 to 8 do Result[Li] := Perm[Li];
end;

function TSudoku.GrilleRotation(const AngleDeg: integer): tStringList;
var j: integer; dPhi: Extended; Poly: array[0..80] of TPos; Res: array[0..8] of string;
  Rxx, Ryy, xc, yc: Double; s: string; Li, Co: byte; c: char;
begin
  dPhi := DegToRad(AngleDeg); Result := SLGrille;
  for Li := 0 to 8 do begin
    s := Result[Li];
    for Co := 1 to 9 do begin
      c := s[Co]; j := Li * 9 + Co - 1; if j > 81 then sms('j>81');
      Poly[j].Cand := [c]; Poly[j].Li := Li; Poly[j].Co := Co;
    end;
  end;
  xc := Poly[40].Co; yc := Poly[40].Li;
  for j := 0 to 80 do begin
    Rxx := Poly[j].Co - xc; Ryy := Poly[j].Li - yc;
    // Application de la matrice de rotation par rapport au centre de coordonnes xc,yc
    Poly[j].Co := round(xc + (Rxx * cos(dPhi) - Ryy * sin(dPhi)));
    Poly[j].Li := round(yc + (Rxx * sin(dPhi) + Ryy * cos(dPhi)));
  end;
  for Li := 0 to 8 do Res[Li] := '000000000';
  for j := 0 to 80 do begin
    s := CandiToStr(Poly[j].Cand);
    if s <> '' then Res[Poly[j].Li][Poly[j].Co] := s[1] else Res[Poly[j].Li][Poly[j].Co] := '0';
  end;
  for Li := 0 to 8 do Result[Li] := Res[Li];
end;

function TSudoku.GrillePermuterVr1Vr2(const Vr1, Vr2: char): tStringList;
//      Permuter deux valeurs rvles dans la grille
var Li, Co: byte; s: string;
begin
  Result := SLGrille;
  for Li := 0 to 8 do begin
    s := Result[Li];
    for Co := 1 to 9 do begin
      if s[Co] = Vr1 then s[Co] := Vr2 else if s[Co] = Vr2 then s[Co] := Vr1;
    end;
    Result[Li] := s;
  end;
end;

initialization
  Randomize;
  SetLength(ArrCol, 6);
  ArrCol[0] := clYellow;
  ArrCol[1] := clLime;
  ArrCol[2] := clFuchsia;
  ArrCol[3] := clTeal;
  ArrCol[4] := clGreen;
  ArrCol[5] := clBlue;

end. // ///////////////////////////////////////////////////

